SortGroupInformation = {};
local L = LibStub("AceLocale-3.0"):GetLocale("SortGroup")
SortGroup_Variable_CompactSave = {}

local SortGroup_Variable_frame = {};
SortGroup_Variable_frame = CreateFrame("Frame", "SortGroupPanel", UIParent);
local SortGroup_Variable_framePage2_AdditionalSwitch = CreateFrame("Frame", "SortGroupPanelPage2_AdditionalSwitch", SortGroup_Variable_frame);
local SortGroup_Variable_framePage3_Options = CreateFrame("Frame", "SortGroupPanelPage2_Options", SortGroup_Variable_frame);
-- Main Frame

SortGroup_Variable_GroupTop = false;
SortGroup_Variable_GroupBottom = false;
SortGroup_Variable_GroupTopDownwards = false;
SortGroup_Variable_GroupTopUpwards = false;
SortGroup_Variable_GroupBottomDownwards = false;
SortGroup_Variable_GroupBottomUpwards = false;
SortGroup_Variable_RegardlessRaidProfile = false;
SortGroup_Variable_GroupAutoActivate = false;
SortGroup_Variable_raidProfile = nil;
SortGroup_Variable_cacheAutoActive = nil;

SortGroup_Variable_Page2_AdditionalSwitchActive = false;
SortGroup_Variable_Page2_AdditionalSwitchraidProfile = nil;
SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved = nil;
SortGroup_Variable_Page2_AdditionalSwitchddmSavedProfilesCounter = 0;
SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad = {};
SortGroup_Variable_Page2_AdditionalSwitchArray = {}
SortGroup_Variable_Page2_AdditionalSwitchraidProfilOnThatPlace = "";

SortGroup_Variable_Page3_chatMessagesOn = true;
SortGroup_Variable_Page3_ChangesInCombat = false;
SortGroup_Variable_Page3_RaidProfilesUpdateInCombat = false;
-- SortGroup_Variable_cacheAutoActive intern cache for AutoActivate
-- Page2_AdditionalSwitchddmSavedProfiles count, necessary for deleting
-- SortGroup_Variable_Page2_AdditionalSwitchraidProfilOnThatPlace, changeOwnElemnt = false -> RaidProfile
-- Chosen Options

SortGroup_Variable_showChatMessage = false;
-- true when "PLAYER_ENTERING_WORLD" fired or cb Event gets triggerd

SortGroup_Variable_inCombat = false;
-- true when "PLAYER_REGEN_DISABLED" fired

SortGroup_Variable_Page3_Options_DebugMode = false;
SortGroup_Variable_Page3_Options_DebugModeLevel1 = false;
SortGroup_Variable_Page3_Options_DebugModeLevel2 = false;
SortGroup_Variable_Page3_Options_DebugModeLevel3 = false;
SortGroup_Variable_debuglevel = 0;
-- debuging, false = deactivated
-- 1 Options
-- 2 Events+Method Names
-- 4 Methods content
-- combinable

SortGroup_Variable_debugLevelCache = nil;
SortGroup_Variable_debugMethodNameCache = nil;
SortGroup_Variable_debugMethodContentCache = nil;
SortGroup_Variable_debugMethodNamePrint = true;
-- Intern cache, to display everything better

SortGroup_Variable_raidProfilOnLoadIndex = 0;

SortGroup_Variable_playerChangeRaidProfileIntern = false;
-- true if player change Raid Profile

local manager = CompactRaidFrameManager;
local old_CompactUnitFrameProfiles_ActivateRaidProfile = CompactUnitFrameProfiles_ActivateRaidProfile;

local framePage3_Options_NormalText = CreateFrame("SimpleHTML", "framePage3_Options_NormalText_Text", SortGroup_Variable_framePage3_Options);
local framePage3_Options_CriticalText = CreateFrame("SimpleHTML", "framePage3_Options_NormalText_Text", SortGroup_Variable_framePage3_Options);
-- Text

local cBTop = CreateFrame("CheckButton", "CheckButtonTop_Text", SortGroup_Variable_frame, "UICheckButtonTemplate");
local cBBottom = CreateFrame("CheckButton", "CheckButtonBottom_Text", SortGroup_Variable_frame, "UICheckButtonTemplate");
local cbTopDownwards = CreateFrame("CheckButton", "CheckButtonTopDownwards_Text", cBTop, "UICheckButtonTemplate");
local cbTopUpwards = CreateFrame("CheckButton", "CheckButtonTopUpwards_Text", cBTop, "UICheckButtonTemplate");
local cbBottomDownwards = CreateFrame("CheckButton", "CheckButtonBottomDownwards_Text", cBBottom, "UICheckButtonTemplate");
local cbBottomUpwards = CreateFrame("CheckButton", "CheckButtonBottomUpwards_Text", cBBottom, "UICheckButtonTemplate");
local cbRegardlessRaidProfile = CreateFrame("CheckButton", "CheckButtonRegardlessRaidProfile_Text", SortGroup_Variable_frame, "UICheckButtonTemplate");
local cbAutoActivate = CreateFrame("CheckButton", "CheckButtonAutoActivate_Text", cbRegardlessRaidProfile, "UICheckButtonTemplate");

local Page2_AdditionalSwitchcbActive = CreateFrame("CheckButton", "CheckButtonPage2_AdditionalSwitchActive_Text", SortGroup_Variable_framePage2_AdditionalSwitch, "UICheckButtonTemplate");

local Page3_cbChatMessagesOn = CreateFrame("CheckButton", "CheckButtonChatMessagesOn_Text", framePage3_Options_NormalText, "UICheckButtonTemplate");
local Page3_cbChangesInCombat = CreateFrame("CheckButton", "CheckButtonChangesInCombat_Text", framePage3_Options_CriticalText, "UICheckButtonTemplate");
local Page3_cbRaidProfilesUpdateInCombat = CreateFrame("CheckButton", "CheckButtonRaidProfilesUpdateInCombat_Text", framePage3_Options_NormalText, "UICheckButtonTemplate");
local Page3_cbDebugMode = CreateFrame("CheckButton", "CheckButtonDebugMode_Text", framePage3_Options_CriticalText, "UICheckButtonTemplate");
local Page3_cbDebugModeLevel1 = CreateFrame("CheckButton", "CheckButtonDebugLevel1Mode_Text", Page3_cbDebugMode, "UICheckButtonTemplate");
local Page3_cbDebugModeLevel2 = CreateFrame("CheckButton", "CheckButtonDebugLevel2Mode_Text", Page3_cbDebugMode, "UICheckButtonTemplate");
local Page3_cbDebugModeLevel3 = CreateFrame("CheckButton", "CheckButtonDebugLevel3Mode_Text", Page3_cbDebugMode, "UICheckButtonTemplate");
-- Combo-box Options

local Page2_AdditionalSwitchbtnSave = CreateFrame("Button", "Page2_AdditionalSwitchbtnSave_Text", SortGroup_Variable_framePage2_AdditionalSwitch, "UIPanelButtonTemplate");
local Page2_AdditionalSwitchbtnDelete = CreateFrame("Button", "Page2_AdditionalSwitchbtnDelete_Text", SortGroup_Variable_framePage2_AdditionalSwitch, "UIPanelButtonTemplate");
local Page2_AdditionalSwitchbtnReset = CreateFrame("Button", "Page2_AdditionalSwitchbtnReset_Text", SortGroup_Variable_framePage2_AdditionalSwitch, "UIPanelButtonTemplate");

local Page3_OptionsbtnReload = CreateFrame("Button", "page3btnReload_Text", SortGroup_Variable_framePage3_Options, "UIPanelButtonTemplate");
-- Button

local ddmProfiles = CreateFrame("Button", "DropDownMenuProfiles", cbAutoActivate, "UIDropDownMenuTemplate");
local Page2_AdditionalSwitchddmProfiles = CreateFrame("Button", "DropDownMenuPage2_AdditionalSwitchProfiles", SortGroup_Variable_framePage2_AdditionalSwitch, "UIDropDownMenuTemplate");
local Page2_AdditionalSwitchddmSavedProfiles = CreateFrame("Button", "Page2_AdditionalSwitchddmSavedProfiles", SortGroup_Variable_framePage2_AdditionalSwitch, "UIDropDownMenuTemplate");
SortGroup_Variable_ddmItems = {};
-- DropDownMenu

local Page2_AdditionalSwitchSliderMinimum = CreateFrame("Slider", "Page2_AdditionalSwitchSliderMinimum_Text", SortGroup_Variable_framePage2_AdditionalSwitch, "OptionsSliderTemplate");
local Page2_AdditionalSwitchSliderMaximum = CreateFrame("Slider", "Page2_AdditionalSwitchSliderMaximum_Text", SortGroup_Variable_framePage2_AdditionalSwitch, "OptionsSliderTemplate");
-- Sliders

local Page2_AdditionalSwitchTextFrom = CreateFrame("SimpleHTML", "Page2_AdditionalSwitchTextFrom_Text", SortGroup_Variable_framePage2_AdditionalSwitch);
local Page2_AdditionalSwitchTextTo = CreateFrame("SimpleHTML", "Page2_AdditionalSwitch_AdditionalSwitchTextTo_Text", SortGroup_Variable_framePage2_AdditionalSwitch);
local Page2_AdditionalSwitchAvailableText = CreateFrame("SimpleHTML", "Page2_AvailableText_Text", SortGroup_Variable_framePage2_AdditionalSwitch);
local Page2_AdditionalSwitchSavedText = CreateFrame("SimpleHTML", "Page2_AdditionalSwitch_AvailableText_Text", SortGroup_Variable_framePage2_AdditionalSwitch);

local textVersion = CreateFrame("SimpleHTML", "textVersion_Text", SortGroup_Variable_frame);
local textAuthor = CreateFrame("SimpleHTML", "textAuthor_Text", SortGroup_Variable_frame);
local version = "3.2.22";
local author = "Collabo93"

local defaultColor = "#FFFFFF";
---End Variables



local function createFrame()	
	Debug("createFrame", "", 2);
	SortGroup_Variable_frame.name = "SortGroup";
	fontFrame = SortGroup_Variable_frame:CreateFontString("SortGroup_Title", "OVERLAY", "GameFontHighlight");
	fontFrame:SetFont("Fonts\\FRIZQT__.TTF", 18);
	fontFrame:SetTextColor(1, 0.8, 0);
    fontFrame:SetPoint("TOPLEFT", 12, -18);
    fontFrame:SetText("SortGroup".."|r");
	SortGroup_Variable_frame.okay = function(SortGroup_Variable_frame)
		Debug("InterfaceOptionsFrameOkay", "", 2);
		SendSortOptionToSortBy(false);
	end
	SortGroup_Variable_frame.cancel = function(SortGroup_Variable_frame)
		Debug("InterfaceOptionsFrameCancel", "", 2);
		SendSortOptionToSortBy(false);
	end
	InterfaceOptions_AddCategory(SortGroup_Variable_frame);
	
	SortGroup_Variable_framePage2_AdditionalSwitch.name = L["framePage2_AdditionalSwitch_Name"];
	fontFramePage2_AdditionalSwitch = SortGroup_Variable_framePage2_AdditionalSwitch:CreateFontString("SortGroup_Title", "OVERLAY", "GameFontHighlight");
	fontFramePage2_AdditionalSwitch:SetFont("Fonts\\FRIZQT__.TTF", 18);
	fontFramePage2_AdditionalSwitch:SetTextColor(1, 0.8, 0);
    fontFramePage2_AdditionalSwitch:SetPoint("TOPLEFT", 12, -18);
    fontFramePage2_AdditionalSwitch:SetText(L["framePage2_AdditionalSwitch_description"].."|r");
	SortGroup_Variable_framePage2_AdditionalSwitch.parent = SortGroup_Variable_frame.name;
	InterfaceOptions_AddCategory(SortGroup_Variable_framePage2_AdditionalSwitch);
	
	SortGroup_Variable_framePage3_Options.name = L["fontFramePage3_Options_Name"];
	fontFramePage3_Options = SortGroup_Variable_framePage3_Options:CreateFontString("SortGroup_Title", "OVERLAY", "GameFontHighlight");
	fontFramePage3_Options:SetFont("Fonts\\FRIZQT__.TTF", 18);
	fontFramePage3_Options:SetTextColor(1, 0.8, 0);
    fontFramePage3_Options:SetPoint("TOPLEFT", 12, -18);
    fontFramePage3_Options:SetText(L["fontFramePage3_Options_Name"].."|r");
	SortGroup_Variable_framePage3_Options.parent = SortGroup_Variable_frame.name;
	InterfaceOptions_AddCategory(SortGroup_Variable_framePage3_Options);
end

local function createText()
	Debug("createText", "", 2);
	textVersion:SetSize(200, 20);
	textVersion:SetPoint("TOPLEFT", 13,-45);
	textVersion:SetFontObject(GameFontHighlightSmall);
	textVersion:SetText("|cFF00FF00Version  |r" .. version);
	
	textAuthor:SetSize(200, 20);
	textAuthor:SetPoint("TOPLEFT", 13,-55);
	textAuthor:SetFontObject(GameFontHighlightSmall);
	textAuthor:SetText("|cFF00FF00Author   |r" .. author);
	
	Page2_AdditionalSwitchTextFrom:SetSize(200, 20);
	Page2_AdditionalSwitchTextFrom:SetPoint("TOPLEFT", 220,-90);
	Page2_AdditionalSwitchTextFrom:SetFontObject(GameFontHighlightMedium);
	Page2_AdditionalSwitchTextFrom:SetText("|cFF00FF00" .. L["Page2_AdditionalSwitchTextFrom"]);
	
	Page2_AdditionalSwitchTextTo:SetSize(200, 20);
	Page2_AdditionalSwitchTextTo:SetPoint("TOPLEFT", 380,-205);
	Page2_AdditionalSwitchTextTo:SetFontObject(GameFontHighlightMedium);
	Page2_AdditionalSwitchTextTo:SetText("|cFF00FF00" .. L["Page2_AdditionalSwitchTextTo"]);
	
	Page2_AdditionalSwitchAvailableText:SetSize(200, 20);
	Page2_AdditionalSwitchAvailableText:SetPoint("TOPLEFT", 50,-120);
	Page2_AdditionalSwitchAvailableText:SetFontObject(GameFontHighlightMedium);
	Page2_AdditionalSwitchAvailableText:SetText(L["Page2_AdditionalSwitchAvailableText"]);
	
	Page2_AdditionalSwitchSavedText:SetSize(200, 20);
	Page2_AdditionalSwitchSavedText:SetPoint("TOPLEFT", 450,-120);
	Page2_AdditionalSwitchSavedText:SetFontObject(GameFontHighlightMedium);
	Page2_AdditionalSwitchSavedText:SetText(L["Page2_AdditionalSwitchSavedText"]);
	
	framePage3_Options_NormalText:SetSize(200, 20);
	framePage3_Options_NormalText:SetPoint("TOPLEFT", 50,-80);
	framePage3_Options_NormalText:SetFontObject(GameFontHighlightMedium);
	framePage3_Options_NormalText:SetText(L["Page3_Options_NormalText"]);
	
	framePage3_Options_CriticalText:SetSize(200, 20);
	framePage3_Options_CriticalText:SetPoint("TOPLEFT", 350,-80);
	framePage3_Options_CriticalText:SetFontObject(GameFontHighlightMedium);
	framePage3_Options_CriticalText:SetText(L["Page3_Options_CriticalText"]);
	
end

local function createCheckbox()	
	Debug("createCheckbox", "", 2);
	cBTop:SetPoint("TOPLEFT", 10, -100);
	cBBottom:SetPoint("TOPLEFT",10, -200);
	cbTopDownwards:SetPoint("TOPLEFT", 30, -30);
	cbTopUpwards:SetPoint("TOPLEFT", 30, -55);
	cbBottomDownwards:SetPoint("TOPLEFT", 30, -30);
	cbBottomUpwards:SetPoint("TOPLEFT", 30, -55);
	cbRegardlessRaidProfile:SetPoint("TOPLEFT",340,-100);
	cbAutoActivate:SetPoint("TOPLEFT",30,-30);
	
	getglobal(cBTop:GetName() .. 'Text'):SetText(ColorPrint(L["cBTop_Option_Text"], "white"));
	getglobal(cBBottom:GetName() .. 'Text'):SetText(ColorPrint(L["cBBottom_Option_Text"], "white"));
	getglobal(cbTopDownwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbDownwards_Option_Text"], "white"));
	getglobal(cbTopUpwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbUpwards_Option_Text"], "white"));
	getglobal(cbBottomDownwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbDownwards_Option_Text"], "white"));
	getglobal(cbBottomUpwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbUpwards_Option_Text"], "white"));
	getglobal(cbAutoActivate:GetName() .. 'Text'):SetText(ColorPrint(L["cbAutoActivate_Option_Text"], "white"));
	getglobal(cbRegardlessRaidProfile:GetName() .. 'Text'):SetText(ColorPrint(L["cbRegardlessRaidProfile_Option_Text"], "white"));
	--Page1
	
	Page2_AdditionalSwitchcbActive:SetPoint("TOPLEFT", 10, -60);
	getglobal(Page2_AdditionalSwitchcbActive:GetName() .. 'Text'):SetText(ColorPrint(L["Page2_AdditionalSwitchcbActive_Option_Text"], "white"));
	--Page2
	
	Page3_cbChatMessagesOn:SetPoint("TOPLEFT",10,-30);
	Page3_cbRaidProfilesUpdateInCombat:SetPoint("TOPLEFT",10,-60);
	Page3_cbChangesInCombat:SetPoint("TOPLEFT",10,-30);
	Page3_cbDebugMode:SetPoint("TOPLEFT",10,-60);
	Page3_cbDebugModeLevel1:SetPoint("TOPLEFT",30,-30);
	Page3_cbDebugModeLevel2:SetPoint("TOPLEFT",30,-60);
	Page3_cbDebugModeLevel3:SetPoint("TOPLEFT",30,-90);
	getglobal(Page3_cbChatMessagesOn:GetName() .. 'Text'):SetText(ColorPrint(L["Page3_cbChatMessagesOn_Option_Text"], "white"));
	getglobal(Page3_cbChangesInCombat:GetName() .. 'Text'):SetText(ColorPrint(L["Page3_ChangesInCombat_Option_Text"], "white"));
	getglobal(Page3_cbRaidProfilesUpdateInCombat:GetName() .. 'Text'):SetText(ColorPrint(L["Page3_RaidProfilesUpdateInCombat_Option_Text"], "white"));
	getglobal(Page3_cbDebugMode:GetName() .. 'Text'):SetText(ColorPrint(L["Page3_cbDebugMode_Option_Text"], "white"));
	getglobal(Page3_cbDebugModeLevel1:GetName() .. 'Text'):SetText(ColorPrint(L["Page3_cbDebugModeLevel1_Option_Text"], "white"));
	getglobal(Page3_cbDebugModeLevel2:GetName() .. 'Text'):SetText(ColorPrint(L["Page3_cbDebugModeLevel2_Option_Text"], "white"));
	getglobal(Page3_cbDebugModeLevel3:GetName() .. 'Text'):SetText(ColorPrint(L["Page3_cbDebugModeLevel3_Option_Text"], "white"));
	--Page3
end

local function createButton()
	Debug("createButton", "", 2);
	Page2_AdditionalSwitchbtnSave:SetSize(120, 24);
	Page2_AdditionalSwitchbtnSave:SetText(L["Page2_AdditionalSwitchbtnSave_text"]);
	Page2_AdditionalSwitchbtnSave:SetPoint("Topleft", 300, -260)
	
	Page2_AdditionalSwitchbtnDelete:SetSize(120, 24);
	Page2_AdditionalSwitchbtnDelete:SetText(L["Page2_AdditionalSwitchbtnDelete_text"]);
	Page2_AdditionalSwitchbtnDelete:SetPoint("Topleft", 450, -260)
	
	Page2_AdditionalSwitchbtnReset:SetSize(120, 24);
	Page2_AdditionalSwitchbtnReset:SetText(L["Page2_AdditionalSwitchbtnReset_text"]);
	Page2_AdditionalSwitchbtnReset:SetPoint("Topleft", 450, -300)
	
	Page3_OptionsbtnReload:SetSize(120, 24);
	Page3_OptionsbtnReload:SetText(L["Page3_OptionsbtnReload_text"]);
	Page3_OptionsbtnReload:SetPoint("Topleft", 40, -450)
end

local function createDropDownMenu()
	Debug("createDropDownMenu", "", 2);
	ddmProfiles.text = _G["DropDownMenuProfiles"];
	ddmProfiles.text:SetText("Empty ddm");
	ddmProfiles:SetPoint("TOPLEFT", -10, -30);		
	ddmProfiles.info = {};
	ddmProfiles.initialize = function(self, level)
		if ( SortGroup_Variable_inCombat == false and level == 1 ) then
			wipe(self.info);
			ReadAllRaidProfiles();
			for i, value in pairs(SortGroup_Variable_ddmItems) do
				self.info.text = value;
				self.info.value = i;
				self.info.func = function(item)
					if ( RaidProfilOnLoadExists(value) == true ) then
						table.remove(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad, SortGroup_Variable_raidProfilOnLoadIndex);
					end
					self.selectedID = item:GetID();
					self.text:SetText(item);
					self.value = i;
					SortGroup_Variable_raidProfile = value;
					UIDropDownMenu_SetText(ddmProfiles, SortGroup_Variable_raidProfile);
					UIDropDownMenu_SetText(Page2_AdditionalSwitchddmProfiles, "");
					SortGroup_Variable_showChatMessage = true;
					DisableSliders();
					fillArray();
					SendSortOptionToSortBy(false);
				end
				self.info.checked = i == self.text:GetText();
				UIDropDownMenu_AddButton(self.info, level);
				if ( SortGroup_Variable_raidProfile == self.info.text ) then
					UIDropDownMenu_SetSelectedID(ddmProfiles, i);
				end
			end
		else
			if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
				print(ColorPrint(L["in_combat_options"], "option"));
			end
		end
	end
	ddmProfiles:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["ddmProfiles_Title"] .. "\n\n" .. ColorPrint(L["ddmProfiles_ToolTip_Text"], "white"), nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	ddmProfiles:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
	
	
	Page2_AdditionalSwitchddmProfiles.text = _G["DropDownMenuProfiles"];
	Page2_AdditionalSwitchddmProfiles.text:SetText("Empty ddm");
	Page2_AdditionalSwitchddmProfiles:SetPoint("TOPLEFT", 25, -140);		
	Page2_AdditionalSwitchddmProfiles.info = {};
	Page2_AdditionalSwitchddmProfiles.initialize = function(self, level)
		if ( SortGroup_Variable_inCombat == false and level == 1 ) then
			wipe(self.info);
			DeleteRaidProfileNotExists();
			ReadAllRaidProfiles();
			for i, value in pairs(SortGroup_Variable_ddmItems) do
				if ( RaidProfilOnLoadExists(value) == false ) then
					self.info.text = value;
					self.info.value = i;
					self.info.func = function(item)
						self.selectedID = item:GetID();
						self.text:SetText(item);
						self.value = i;
						SortGroup_Variable_Page2_AdditionalSwitchraidProfile = value;
						UIDropDownMenu_SetText(Page2_AdditionalSwitchddmSavedProfiles, "");
						UIDropDownMenu_SetText(Page2_AdditionalSwitchddmProfiles, SortGroup_Variable_Page2_AdditionalSwitchraidProfile);					
						SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved = nil;
						if ( SortGroup_Variable_Page2_AdditionalSwitchraidProfile == SortGroup_Variable_raidProfile and SortGroup_Variable_GroupAutoActivate == true ) then
							Page2_AdditionalSwitchSliderMinimum:Disable();
							Page2_AdditionalSwitchSliderMaximum:Disable();
							Page2_AdditionalSwitchbtnSave:Disable();
							Page2_AdditionalSwitchbtnDelete:Disable();
							Page2_AdditionalSwitchSliderMinimum_Text:SetMinMaxValues(2, 5);
							Page2_AdditionalSwitchSliderMaximum_Text:SetMinMaxValues(2, 5);
							Page2_AdditionalSwitchSliderMinimum_Text:SetValue(2);
							Page2_AdditionalSwitchSliderMaximum_Text:SetValue(5);									
							getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Low'):SetText(ColorPrint('2', "disable"));
							getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'High'):SetText(ColorPrint('5', "disable"));
							getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Text'):SetText(ColorPrint(math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue()), "disable"));
							getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Low'):SetText(ColorPrint('2', "disable"));
							getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'High'):SetText(ColorPrint('5', "disable"))
							getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Text'):SetText(ColorPrint(math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue()), "disable"));
						else
							Page2_AdditionalSwitchSliderMinimum:Enable();
							Page2_AdditionalSwitchSliderMaximum:Enable();
							Page2_AdditionalSwitchbtnSave:Enable();
							if ( SortGroup_Variable_GroupAutoActivate == true ) then
								Page2_AdditionalSwitchSliderMinimum_Text:SetMinMaxValues(6, 40);
								Page2_AdditionalSwitchSliderMaximum_Text:SetMinMaxValues(6, 40);
								Page2_AdditionalSwitchSliderMinimum_Text:SetValue(6);
								Page2_AdditionalSwitchSliderMaximum_Text:SetValue(40);
								getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Low'):SetText('6');
								getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'High'):SetText('40');
								getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Low'):SetText('6');
								getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'High'):SetText('40')
							else
								Page2_AdditionalSwitchSliderMinimum_Text:SetMinMaxValues(2, 40);
								Page2_AdditionalSwitchSliderMaximum_Text:SetMinMaxValues(2, 40);
								Page2_AdditionalSwitchSliderMinimum_Text:SetValue(2);
								Page2_AdditionalSwitchSliderMaximum_Text:SetValue(40);
								getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Low'):SetText('2');
								getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'High'):SetText('40');
								getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Low'):SetText('2');
								getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'High'):SetText('40')						
							end
							ColorSliders("ddmProfiles");
						end
					end
					self.info.checked = i == self.text:GetText();
					UIDropDownMenu_AddButton(self.info, level);
					if ( SortGroup_Variable_Page2_AdditionalSwitchraidProfile == self.info.text ) then
						UIDropDownMenu_SetSelectedID(Page2_AdditionalSwitchddmProfiles, i)
					end
				end
			end
		else
			if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
				print(ColorPrint(L["in_combat_options"], "option"));
			end
		end
	end
	Page2_AdditionalSwitchddmProfiles:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["Page2_AdditionalSwitchAvailableText"] .. "\n\n" .. ColorPrint(L["Page2_AdditionalSwitchddmProfiles_ToolTip_Text"], "white"), nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	Page2_AdditionalSwitchddmProfiles:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	
	
	Page2_AdditionalSwitchddmSavedProfiles.text = _G["DropDownMenuProfiles"];
	Page2_AdditionalSwitchddmSavedProfiles.text:SetText("Empty ddm");
	Page2_AdditionalSwitchddmSavedProfiles:SetPoint("TOPLEFT", 425, -140);		
	Page2_AdditionalSwitchddmSavedProfiles.info = {};
	Page2_AdditionalSwitchddmSavedProfiles.initialize = function(self, level)
		if ( SortGroup_Variable_inCombat == false and level == 1 ) then
			wipe(self.info);
			DeleteRaidProfileNotExists()
			SortGroup_Variable_Page2_AdditionalSwitchddmSavedProfilesCounter = 0;
			for i = 1, (CountTable(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad)), 1 do
				self.info.text = SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].RaidProfileName;
				self.info.value = i;
				SortGroup_Variable_Page2_AdditionalSwitchddmSavedProfilesCounter = SortGroup_Variable_Page2_AdditionalSwitchddmSavedProfilesCounter + 1;
				self.info.func = function(item)
					self.selectedID = item:GetID();
					self.text:SetText(item);
					self.value = i;
					SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved = SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].RaidProfileName;
					UIDropDownMenu_SetText(Page2_AdditionalSwitchddmSavedProfiles, SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved);
					UIDropDownMenu_SetText(Page2_AdditionalSwitchddmProfiles, "");
					Page2_AdditionalSwitchbtnDelete:Enable();
					Page2_AdditionalSwitchbtnSave:Enable();
					Page2_AdditionalSwitchSliderMinimum:Enable();
					Page2_AdditionalSwitchSliderMaximum:Enable();
					SortGroup_Variable_Page2_AdditionalSwitchraidProfile = nil;
					if ( SortGroup_Variable_GroupAutoActivate == true ) then
						Page2_AdditionalSwitchSliderMinimum_Text:SetMinMaxValues(6, 40);
						Page2_AdditionalSwitchSliderMaximum_Text:SetMinMaxValues(6, 40);
						Page2_AdditionalSwitchSliderMinimum_Text:SetValue(6);
						Page2_AdditionalSwitchSliderMaximum_Text:SetValue(40);
						getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Low'):SetText('6');
						getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'High'):SetText('40');
						getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Low'):SetText('6');
						getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'High'):SetText('40')
					else
						Page2_AdditionalSwitchSliderMinimum_Text:SetMinMaxValues(2, 40);
						Page2_AdditionalSwitchSliderMaximum_Text:SetMinMaxValues(2, 40);
						getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Low'):SetText('2');
						getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'High'):SetText('40');
						getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Low'):SetText('2');
						getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'High'):SetText('40')			
					end
					ColorSliders("ddmSelectedProfiles",i);
				end
				self.info.checked = i == self.text:GetText();
				UIDropDownMenu_AddButton(self.info, level);
				if ( Page2_AdditionalSwitchddmSavedProfiles == self.info.text ) then
					UIDropDownMenu_SetSelectedID(Page2_AdditionalSwitchddmSavedProfiles, i)
				end
			end
		else
			if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
				print(ColorPrint(L["in_combat_options"], "option"));
			end
		end
	end
	Page2_AdditionalSwitchddmSavedProfiles:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["Page2_AdditionalSwitchSavedText"] .. "\n\n" .. ColorPrint(L["Page2_AdditionalSwitchddmSelectedProfiles_ToolTip_Text"], "white"), nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	Page2_AdditionalSwitchddmSavedProfiles:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
end
--DropDownMenu creating, include items

local function createSliders()
	Debug("createSliders", "", 2);
	Page2_AdditionalSwitchSliderMinimum_Text:SetSize(150, 17);
	Page2_AdditionalSwitchSliderMinimum_Text:SetPoint("TOPLEFT",230,-120);
	Page2_AdditionalSwitchSliderMinimum_Text:SetOrientation('HORIZONTAL');
	Page2_AdditionalSwitchSliderMinimum_Text:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal");
	Page2_AdditionalSwitchSliderMinimum_Text:SetMinMaxValues(2,40);
	Page2_AdditionalSwitchSliderMinimum_Text:SetValue(2);
	getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Low'):SetText('2');
	getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'High'):SetText('40');
	getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Text'):SetText(Page2_AdditionalSwitchSliderMinimum:GetValue());
	Page2_AdditionalSwitchSliderMinimum_Text:SetBackdrop({
		bgFile = "Interface\\Buttons\\UI-SliderBar-Background", 
		edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
		tile = true, tileSize = 8, edgeSize = 8, 
		insets = { left = 3, right = 3, top = 6, bottom = 6 }})
	Page2_AdditionalSwitchSliderMinimum_Text:SetValueStep(1);
	
	Page2_AdditionalSwitchSliderMaximum_Text:SetSize(150, 17);
	Page2_AdditionalSwitchSliderMaximum_Text:SetPoint("TOPLEFT", 230,-170);
	Page2_AdditionalSwitchSliderMaximum_Text:SetOrientation('HORIZONTAL');
	Page2_AdditionalSwitchSliderMaximum_Text:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal");
	Page2_AdditionalSwitchSliderMaximum_Text:SetMinMaxValues(2,40);
	Page2_AdditionalSwitchSliderMaximum_Text:SetValue(40);
	getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Low'):SetText('2');
	getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'High'):SetText('40');
	getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Text'):SetText(Page2_AdditionalSwitchSliderMaximum:GetValue());
	Page2_AdditionalSwitchSliderMaximum_Text:SetBackdrop({
		bgFile = "Interface\\Buttons\\UI-SliderBar-Background", 
		edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
		tile = true, tileSize = 8, edgeSize = 8, 
		insets = { left = 3, right = 3, top = 6, bottom = 6 }})
	Page2_AdditionalSwitchSliderMaximum_Text:SetValueStep(1);
end
--- End Creating



local function frameEvent()
	Debug("frameEvent", "", 2);
	SortGroup_Variable_frame:RegisterEvent("COMPACT_UNIT_FRAME_PROFILES_LOADED");
	SortGroup_Variable_frame:RegisterEvent("PLAYER_ENTERING_WORLD");
	SortGroup_Variable_frame:RegisterEvent("PLAYER_LOGOUT");
	SortGroup_Variable_frame:RegisterEvent("PLAYER_REGEN_DISABLED");
	SortGroup_Variable_frame:RegisterEvent("PLAYER_REGEN_ENABLED");
	SortGroup_Variable_frame:RegisterEvent("GROUP_ROSTER_UPDATE");
	SortGroup_Variable_frame:RegisterEvent("PARTY_MEMBERS_CHANGED");
	SortGroup_Variable_frame:SetScript("OnEvent", 
		function(self, event, ...)	
			if ( event == "PLAYER_LOGOUT" ) then 
				Debug("PLAYER_LOGOUT", "", 1);
				SaveOptions();
				SortGroup_Variable_frame:UnregisterEvent(event);
			elseif ( event == "PLAYER_REGEN_DISABLED" ) then
				Debug("PLAYER_REGEN_DISABLED", "", 1);
				SortGroup_Variable_inCombat = true;
			elseif ( event == "PLAYER_REGEN_ENABLED" ) then
				Debug("PLAYER_REGEN_ENABLED", "", 1);
				SortGroup_Variable_inCombat = false;
				for k, v in pairs(SortGroup_Variable_CompactSave) do
					SortGroup_Variable_CompactSave[k] = nil
					_G[v](_G[k])
				end
				SendSortOptionToSortBy(false);
			elseif ( event == "GROUP_ROSTER_UPDATE" or event == "PARTY_MEMBERS_CHANGED" ) then
				Debug("GROUP_ROSTER_UPDATE", "", 1);
				if ( SortGroup_Variable_Page2_AdditionalSwitchActive == true ) then
					SwitchRaidProfiles();
					if ( SortGroupIsActive() == true ) then
						SendSortOptionToSortBy(false);
					end
				end
			elseif ( event == "COMPACT_UNIT_FRAME_PROFILES_LOADED" ) then
				Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "", 1)
				if ( SortGroupInformation.Down == nil or SortGroupInformation.Up == nil ) then
					SortGroupInformation.Down = true;
					SortGroupInformation.Up = false;
					Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "Down/Up = nil - new");
				end	
				if ( SortGroupInformation.TopDownwards == nil or SortGroupInformation.TopUpwards == nil or SortGroupInformation.BottomDownwards == nil or SortGroupInformation.BottomUpwards == nil) then
					if ( SortGroupInformation.Down == true ) then	
						SortGroupInformation.TopDownwards = true;
						SortGroupInformation.TopUpwards	= false;
						SortGroupInformation.BottomDownwards = false;
						SortGroupInformation.BottomUpwards = false;
						Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "Down = true, Down/Up - new");
					elseif ( SortGroupInformation.Up == true ) then
						SortGroupInformation.TopDownwards = false;
						SortGroupInformation.TopUpwards	= false;
						SortGroupInformation.BottomDownwards = false;
						SortGroupInformation.BottomUpwards = true;
						Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "Up = true, Down/Up - new");
					else
						SortGroupInformation.TopDownwards = false;
						SortGroupInformation.TopUpwards	= false;
						SortGroupInformation.BottomDownwards = false;
						SortGroupInformation.BottomUpwards = false;
						Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "Down = false, Up = false - error");
					end
				end
				if ( SortGroupInformation.Profile == nil ) then
					SortGroupInformation.Profile = GetRaidProfileName(1);
					Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "SortGroupInformation.Profile = nil - new");
				end				
				if ( SortGroupInformation.AutoActivate == nil ) then
					SortGroupInformation.AutoActivate = true;
					Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "SortGroupInformation.AutoActivate = nil - new");
				end				
				if ( SortGroupInformation.SortGroup_Variable_RegardlessRaidProfile == nil ) then
					SortGroupInformation.SortGroup_Variable_RegardlessRaidProfile = false;
					Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "SortGroupInformation.SortGroup_Variable_RegardlessRaidProfile = nil - new");
				end
				if ( SortGroupInformation.chatMessagesOn ~= nil ) then
					SortGroupInformation.Page3_ChatMessagesOn = SortGroupInformation.chatMessagesOn;
					SortGroupInformation.chatMessagesOn = nil;
					-- Delete old variable - chatMessagesOn
				end
				if ( SortGroupInformation.SortGroup_Variable_Page2_AdditionalSwitchActive == nil ) then
					SortGroupInformation.SortGroup_Variable_Page2_AdditionalSwitchActive = false;
					Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "SortGroupInformation.SortGroup_Variable_Page2_AdditionalSwitchActive = nil - new");
				end
				if ( SortGroupInformation.RaidProfileOnLoad == nil ) then
					SortGroupInformation.RaidProfileOnLoad = {};	
					Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "SortGroupInformation.RaidProfileOnLoad = nil - new");					
				end
					if ( SortGroupInformation.SortGroup_Variable_Page3_chatMessagesOn == nil ) then
					SortGroupInformation.SortGroup_Variable_Page3_chatMessagesOn = true;
					Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "SortGroupInformation.SortGroup_Variable_Page3_chatMessagesOn = nil - new");
				end
				if ( SortGroupInformation.SortGroup_Variable_Page3_ChangesInCombat == nil ) then
					SortGroupInformation.SortGroup_Variable_Page3_ChangesInCombat = false;	
					Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "SortGroupInformation.SortGroup_Variable_Page3_ChangesInCombat = nil - new");					
				end
				if ( SortGroupInformation.SortGroup_Variable_Page3_RaidProfilesUpdateInCombat == nil ) then
					SortGroupInformation.SortGroup_Variable_Page3_RaidProfilesUpdateInCombat = false;	
					Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "SortGroupInformation.SortGroup_Variable_Page3_RaidProfilesUpdateInCombat = nil - new");					
				end
				if ( SortGroupInformation.SortGroup_Variable_Page3_Options_DebugMode == nil ) then
					SortGroupInformation.SortGroup_Variable_Page3_Options_DebugMode = false;
					SortGroupInformation.SortGroup_Variable_Page3_Options_DebugModeLevel1 = false;
					SortGroupInformation.SortGroup_Variable_Page3_Options_DebugModeLevel2 = false;
					SortGroupInformation.SortGroup_Variable_Page3_Options_DebugModeLevel3 = false;
				end
				
				SortGroup_Variable_GroupTop = SortGroupInformation.Down;
				SortGroup_Variable_GroupBottom = SortGroupInformation.Up;
				SortGroup_Variable_GroupTopDownwards = SortGroupInformation.TopDownwards;
				SortGroup_Variable_GroupTopUpwards = SortGroupInformation.TopUpwards;
				SortGroup_Variable_GroupBottomDownwards = SortGroupInformation.BottomDownwards;
				SortGroup_Variable_GroupBottomUpwards = SortGroupInformation.BottomUpwards;
				SortGroup_Variable_GroupAutoActivate = SortGroupInformation.AutoActivate;
				SortGroup_Variable_RegardlessRaidProfile = SortGroupInformation.SortGroup_Variable_RegardlessRaidProfile;
				SortGroup_Variable_raidProfile = SortGroupInformation.Profile;
				
				SortGroup_Variable_Page2_AdditionalSwitchActive = SortGroupInformation.SortGroup_Variable_Page2_AdditionalSwitchActive;
				SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad = SortGroupInformation.RaidProfileOnLoad;
				DeleteRaidProfileNotExists();
				--fillArray();
				
				SortGroup_Variable_Page3_chatMessagesOn = SortGroupInformation.SortGroup_Variable_Page3_chatMessagesOn;
				SortGroup_Variable_Page3_ChangesInCombat = SortGroupInformation.SortGroup_Variable_Page3_ChangesInCombat;
				SortGroup_Variable_Page3_RaidProfilesUpdateInCombat = SortGroupInformation.SortGroup_Variable_Page3_RaidProfilesUpdateInCombat;
				SortGroup_Variable_Page3_Options_DebugMode = SortGroupInformation.SortGroup_Variable_Page3_Options_DebugMode;
				SortGroup_Variable_Page3_Options_DebugModeLevel1 = SortGroupInformation.SortGroup_Variable_Page3_Options_DebugModeLevel1;
				SortGroup_Variable_Page3_Options_DebugModeLevel2 = SortGroupInformation.SortGroup_Variable_Page3_Options_DebugModeLevel2;
				SortGroup_Variable_Page3_Options_DebugModeLevel3 = SortGroupInformation.SortGroup_Variable_Page3_Options_DebugModeLevel3;
				
				UIDropDownMenu_SetText(ddmProfiles, SortGroup_Variable_raidProfile)
				ChangesComboBoxes();
				--Get informations
				
				resetRaidContainer();
				-- Necessary to put her. Otherwise method doesn't get current variables
				
				ProfileChanged();
				-- Necessary to put her. Otherwise Profiles can get loaded twice or more - > lua error
				
				SortGroup_Variable_showChatMessage = true;
				SendSortOptionToSortBy(false);		
				-- Start sort
				SortGroup_Variable_frame:UnregisterEvent(event);	
			elseif ( event == "PLAYER_ENTERING_WORLD" and HasLoadedCUFProfiles() == true and SortGroup_Variable_inCombat == false) then	
				Debug("PLAYER_ENTERING_WORLD", "", 1);		
				SortGroup_Variable_showChatMessage = false;
				SendSortOptionToSortBy(false);
			end
		end);
end

local function checkBoxEvent()
	Debug("checkBoxEvent", "", 2);
	cBTop:SetScript("OnClick",
		function()
			Debug("cBTop", "", 2);
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				SortGroup_Variable_showChatMessage = true;
				if ( cBTop:GetChecked() == true ) then
					SortGroup_Variable_GroupTop = true;
					SortGroup_Variable_GroupBottom = false;
					if ( cbTopDownwards:GetChecked() == false and cbTopUpwards:GetChecked() == false ) then
						SortGroup_Variable_GroupTopDownwards = true;
					end
				elseif ( cBTop:GetChecked() == false ) then	
					SortGroup_Variable_GroupTop = false;
				end
				SaveOptions();
				ChangesComboBoxes();
				SendSortOptionToSortBy(false);
				Debug("checkBoxEvent", "", 1);
			else
				ChangesComboBoxes(true);
				if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
					print(ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);		
	cBTop:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cBTop_Option_Text"] .."\n\n" .. ColorPrint(L["cBTop_ToolTip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cBTop:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
	--Combobox Top
		
	cBBottom:SetScript("OnClick",
		function()
			Debug("cBBottom", "", 2);
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				SortGroup_Variable_showChatMessage = true;
				if ( cBBottom:GetChecked() == true ) then
					SortGroup_Variable_GroupTop = false;
					SortGroup_Variable_GroupBottom = true;
					if ( cbBottomDownwards:GetChecked() == false and cbBottomUpwards:GetChecked() == false ) then
						SortGroup_Variable_GroupBottomUpwards = true;
						cbBottomUpwards:SetChecked(true);
					end
				elseif ( cBBottom:GetChecked() == false ) then	
					SortGroup_Variable_GroupBottom = false;
				end
				SaveOptions();
				ChangesComboBoxes();
				SendSortOptionToSortBy(false);
				Debug("checkBoxEvent", "", 1);
			else
				ChangesComboBoxes(true);
				if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
					print(ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);
	cBBottom:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cBBottom_Option_Text"] .."\n\n" .. ColorPrint(L["cBBottom_ToolTip_text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cBBottom:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
	--Combobox Bottom
	
	cbTopDownwards:SetScript("OnClick",
		function()
			Debug("cbTopDownwards", "", 2);
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				SortGroup_Variable_showChatMessage = true;
				if ( cbTopDownwards:GetChecked() == true ) then
					SortGroup_Variable_GroupTopDownwards = true;
					SortGroup_Variable_GroupTopUpwards = false;
				elseif ( cbTopDownwards:GetChecked() == false ) then	
					SortGroup_Variable_GroupTopDownwards = false;
				end
				SaveOptions();
				ChangesComboBoxes();
				SendSortOptionToSortBy(false);
				Debug("checkBoxEvent", "", 1);
			else
				ChangesComboBoxes(true);
				if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
					print(ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);		
	cbTopDownwards:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cbDownwards_Option_Text"] .."\n\n" .. ColorPrint(L["cbDownwards_ToolTip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cbTopDownwards:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
	--Combobox cbTopDownwards
	
	cbTopUpwards:SetScript("OnClick",
		function()
			Debug("cbTopUpwards", "", 2);
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				SortGroup_Variable_showChatMessage = true;
				if ( cbTopUpwards:GetChecked() == true ) then
					SortGroup_Variable_GroupTopDownwards = false;
					SortGroup_Variable_GroupTopUpwards = true;
				elseif ( cbTopUpwards:GetChecked() == false ) then	
					SortGroup_Variable_GroupTopUpwards = false;
				end
				SaveOptions();
				ChangesComboBoxes();
				SendSortOptionToSortBy(false);
				Debug("checkBoxEvent", "", 1);
			else
				ChangesComboBoxes(true);
				if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
					print(ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);		
	cbTopUpwards:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cbUpwards_Option_Text"] .."\n\n" .. ColorPrint(L["cbUpwards_ToolTip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cbTopUpwards:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
	--Combobox cbTopDownwards
	
	cbBottomDownwards:SetScript("OnClick",
		function()
			Debug("cbBottomDownwards", "", 2);
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				SortGroup_Variable_showChatMessage = true;
				if ( cbBottomDownwards:GetChecked() == true ) then
					SortGroup_Variable_GroupBottomDownwards = true;
					SortGroup_Variable_GroupBottomUpwards = false;
				elseif ( cbBottomDownwards:GetChecked() == false ) then	
					SortGroup_Variable_GroupBottomDownwards = false;
				end
				SaveOptions();
				SendSortOptionToSortBy(false);
				ChangesComboBoxes();
				Debug("checkBoxEvent", "", 1);
			else
				ChangesComboBoxes(true);
				if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
					print(ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);		
	cbBottomDownwards:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cbDownwards_Option_Text"] .."\n\n" .. ColorPrint(L["cbDownwards_ToolTip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cbBottomDownwards:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
	--Combobox cbTopDownwards
	
	cbBottomUpwards:SetScript("OnClick",
		function()
			Debug("cbBottomUpwards", "", 2);
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				SortGroup_Variable_showChatMessage = true;
				if ( cbBottomUpwards:GetChecked() == true ) then
					SortGroup_Variable_GroupBottomDownwards = false;
					SortGroup_Variable_GroupBottomUpwards = true;
				elseif ( cbBottomUpwards:GetChecked() == false ) then	
					SortGroup_Variable_GroupBottomUpwards = false;
				end
				SaveOptions();
				SendSortOptionToSortBy(false);
				ChangesComboBoxes();
				Debug("checkBoxEvent", "", 1);
			else
				ChangesComboBoxes(true);
				if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
					print(ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);		
	cbBottomUpwards:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cbUpwards_Option_Text"] .."\n\n" .. ColorPrint(L["cbUpwards_ToolTip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cbBottomUpwards:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
	--Combobox cbTopDownwards
		
	cbAutoActivate:SetScript("OnClick",
		function()
			Debug("cbAutoActivate", "", 2);
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				SortGroup_Variable_showChatMessage = true;
				if ( cbAutoActivate:GetChecked() == true ) then
					SortGroup_Variable_GroupAutoActivate = true;
					UIDropDownMenu_SetText(Page2_AdditionalSwitchddmProfiles, "");
					if ( RaidProfilOnLoadExists(SortGroup_Variable_raidProfile) == true ) then
						table.remove(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad, SortGroup_Variable_raidProfilOnLoadIndex);
					end
				elseif ( cbAutoActivate:GetChecked() == false ) then
					SortGroup_Variable_GroupAutoActivate = false;
				end
				UIDropDownMenu_SetText(Page2_AdditionalSwitchddmProfiles, "");
				UIDropDownMenu_SetText(Page2_AdditionalSwitchddmSavedProfiles, "");
				DisableSliders();
				fillArray();
				SaveOptions();
				SendSortOptionToSortBy(false);
				Debug("checkBoxEvent", "", 1);
			else
				ChangesComboBoxes(true);
				if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
					print(ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);		
	cbAutoActivate:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cbAutoActivate_Option_Text"] .."\n\n" .. ColorPrint(L["cbAutoActivate_ToolTip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cbAutoActivate:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	--Combobox AutoActive
		
	cbRegardlessRaidProfile:SetScript("OnClick",
		function()
			Debug("cbRegardlessRaidProfile", "", 2);
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				SortGroup_Variable_showChatMessage = true;
				if ( cbRegardlessRaidProfile:GetChecked() == true ) then
					SortGroup_Variable_RegardlessRaidProfile = true;
					SortGroup_Variable_cacheAutoActive = AutoActivate;
					AutoActivate = false;
					UIDropDownMenu_DisableDropDown(ddmProfiles);
					UIDropDownMenu_SetText(Page2_AdditionalSwitchddmProfiles, "");
				elseif ( cbRegardlessRaidProfile:GetChecked() == false ) then
					SortGroup_Variable_RegardlessRaidProfile = false;
					AutoActivate = SortGroup_Variable_cacheAutoActive;
					cbAutoActivate:Enable();
					UIDropDownMenu_EnableDropDown(ddmProfiles);
					getglobal(cbAutoActivate:GetName() .. 'Text'):SetText(L["cbAutoActivate_Option_Text"]);
				end
				UIDropDownMenu_SetText(Page2_AdditionalSwitchddmProfiles, "");
				UIDropDownMenu_SetText(Page2_AdditionalSwitchddmSavedProfiles, "");
				DisableSliders();
				fillArray();
				SaveOptions();
				ChangesComboBoxes();
				SendSortOptionToSortBy(false);
				Debug("checkBoxEvent", "", 1);
			else
				ChangesComboBoxes(true);
				if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
					print(ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);		
	cbRegardlessRaidProfile:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cbRegardlessRaidProfile_Option_Text"] .."\n\n" .. ColorPrint(L["cbRegardlessRaidProfile_Tooltip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cbRegardlessRaidProfile:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	--Combobox SortGroup_Variable_RegardlessRaidProfile
			
	
	Page2_AdditionalSwitchcbActive:SetScript("OnClick",
		function()
			Debug("Page2_AdditionalSwitchcbActive", "", 2);
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				if ( Page2_AdditionalSwitchcbActive:GetChecked() == true ) then
					SortGroup_Variable_Page2_AdditionalSwitchActive = true;
					UIDropDownMenu_EnableDropDown(Page2_AdditionalSwitchddmProfiles);
					UIDropDownMenu_EnableDropDown(Page2_AdditionalSwitchddmSavedProfiles);
					Page2_AdditionalSwitchbtnReset:Enable();
				elseif ( Page2_AdditionalSwitchcbActive:GetChecked() == false ) then
					SortGroup_Variable_Page2_AdditionalSwitchActive = false;
					UIDropDownMenu_DisableDropDown(Page2_AdditionalSwitchddmProfiles);
					UIDropDownMenu_DisableDropDown(Page2_AdditionalSwitchddmSavedProfiles);
					UIDropDownMenu_SetText(Page2_AdditionalSwitchddmProfiles, "");
					UIDropDownMenu_SetText(Page2_AdditionalSwitchddmSavedProfiles, "");
					Page2_AdditionalSwitchbtnDelete:Disable();
					Page2_AdditionalSwitchbtnReset:Disable();
					DisableSliders();
				end
				SaveOptions();
				Debug("checkBoxEvent", "", 1);
			else
				ChangesComboBoxes(true);
				if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
					print(ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);		
	Page2_AdditionalSwitchcbActive:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:AddLine(L["Page2_AdditionalSwitchcbActive_Option_Text"] .."\n\n" .. ColorPrint(L["Page2_AdditionalSwitchcbActive_Tooltip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	Page2_AdditionalSwitchcbActive:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	--Combobox SortGroup_Variable_Page2_AdditionalSwitchActive
	
	Page3_cbChatMessagesOn:SetScript("OnClick",
		function()
			Debug("Page3_cbChatMessagesOn", "", 2);
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
					if ( Page3_cbChatMessagesOn:GetChecked() == true ) then
						SortGroup_Variable_Page3_chatMessagesOn = true;
						print(ColorPrint(L["chat_Messages_On"], "option"));
					elseif ( Page3_cbChatMessagesOn:GetChecked() == false ) then
						SortGroup_Variable_Page3_chatMessagesOn = false;
					end
					SaveOptions();
					Debug("checkBoxEvent", "", 1);
				else
					ChangesComboBoxes(true);
					if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
						print(ColorPrint(L["in_combat_options"], "option"));
					end
				end
			else
				ChangesComboBoxes(true);
				if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
					print(ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);
	Page3_cbChatMessagesOn:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:AddLine(L["Page3_cbChatMessagesOn_Option_Text"] .."\n\n" .. ColorPrint(L["Page3_cbChatMessagesOn_Tooltip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	Page3_cbChatMessagesOn:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	--Combobox SortGroup_Variable_Page3_chatMessagesOn
	
	Page3_cbChangesInCombat:SetScript("OnClick",
		function()
			Debug("Page3_cbChangesInCombat", "", 2);
			if ( Page3_cbChangesInCombat:GetChecked() == true ) then
				SortGroup_Variable_Page3_ChangesInCombat = true;
			elseif ( Page3_cbChangesInCombat:GetChecked() == false ) then
				SortGroup_Variable_Page3_ChangesInCombat = false;
			end
			SaveOptions();
			Debug("Page3_cbChangesInCombat", "", 1);
		end);
	Page3_cbChangesInCombat:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:AddLine(L["Page3_ChangesInCombat_Option_Text"] .."\n\n" .. ColorPrint(L["Page3_ChangesInCombat_Tooltip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	Page3_cbChangesInCombat:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	--Combobox SortGroup_Variable_Page3_ChangesInCombat
	
	Page3_cbRaidProfilesUpdateInCombat:SetScript("OnClick",
		function()
			Debug("Page3_cbRaidProfilesUpdateInCombat", "", 2);
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				if ( Page3_cbRaidProfilesUpdateInCombat:GetChecked() == true ) then
					SortGroup_Variable_Page3_RaidProfilesUpdateInCombat = true;
				elseif ( Page3_cbRaidProfilesUpdateInCombat:GetChecked() == false ) then
					SortGroup_Variable_Page3_RaidProfilesUpdateInCombat = false;
				end
				SaveOptions();
				Debug("Page3_cbRaidProfilesUpdateInCombat", "", 1);
			else
				ChangesComboBoxes(true);
				if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
					print(ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);
	Page3_cbRaidProfilesUpdateInCombat:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:AddLine(L["Page3_RaidProfilesUpdateInCombat_Option_Text"] .."\n\n" .. ColorPrint(L["Page3_RaidProfilesUpdateInCombat_Tooltip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	Page3_cbRaidProfilesUpdateInCombat:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	--Combobox SortGroup_Variable_Page3_RaidProfilesUpdateInCombat
	
	Page3_cbDebugMode:SetScript("OnClick",
		function()
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				Debug("Page3_cbDebugMode", "", 2);
				if ( Page3_cbDebugMode:GetChecked() == true ) then
					SortGroup_Variable_Page3_Options_DebugMode = true;
				elseif ( Page3_cbDebugMode:GetChecked() == false ) then
					SortGroup_Variable_Page3_Options_DebugMode = false;
				end
				SaveOptions();
				Debug("Page3_cbDebugMode", "", 1);
				ChangesComboBoxes();
				SendSortOptionToSortBy(false);
			else
				ChangesComboBoxes(true);
				if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
					print(ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);
	Page3_cbDebugMode:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:AddLine(L["Page3_cbDebugMode_Option_Text"] .."\n\n" .. ColorPrint(L["Page3_cbDebugMode_Tooltip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	Page3_cbDebugMode:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	
	Page3_cbDebugModeLevel1:SetScript("OnClick",
		function()
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				Debug("Page3_cbDebugModeLevel1", "", 2);
				if ( Page3_cbDebugModeLevel1:GetChecked() == true ) then
					SortGroup_Variable_Page3_Options_DebugModeLevel1 = true;
					SortGroup_Variable_debuglevel = SortGroup_Variable_debuglevel + 1;
				elseif ( Page3_cbDebugModeLevel1:GetChecked() == false ) then
					SortGroup_Variable_Page3_Options_DebugModeLevel1 = false;
					SortGroup_Variable_debuglevel = SortGroup_Variable_debuglevel - 1;
				end
				SaveOptions();
				Debug("Page3_cbDebugModeLevel1", "", 1);
				SendSortOptionToSortBy(false);
			else
				ChangesComboBoxes(true);
				if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
					print(ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);
	Page3_cbDebugModeLevel1:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:AddLine(L["Page3_cbDebugModeLevel1_Option_Text"] .."\n\n" .. ColorPrint(L["Page3_cbDebugModeLevel1_Tooltip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	Page3_cbDebugModeLevel1:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	
	Page3_cbDebugModeLevel2:SetScript("OnClick",
		function()
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				Debug("Page3_cbDebugModeLevel2", "", 2);
				if ( Page3_cbDebugModeLevel2:GetChecked() == true ) then
					SortGroup_Variable_Page3_Options_DebugModeLevel2 = true;
					SortGroup_Variable_debuglevel = SortGroup_Variable_debuglevel + 2;
				elseif ( Page3_cbDebugModeLevel2:GetChecked() == false ) then
					SortGroup_Variable_Page3_Options_DebugModeLevel2 = false;
					SortGroup_Variable_debuglevel = SortGroup_Variable_debuglevel - 2;
				end
				SaveOptions();
				Debug("Page3_cbDebugModeLevel2", "", 1);
				SendSortOptionToSortBy(false);
			else
				ChangesComboBoxes(true);
				if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
					print(ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);
	Page3_cbDebugModeLevel2:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:AddLine(L["Page3_cbDebugModeLevel2_Option_Text"] .."\n\n" .. ColorPrint(L["Page3_cbDebugModeLevel2_Tooltip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	Page3_cbDebugModeLevel2:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	
	Page3_cbDebugModeLevel3:SetScript("OnClick",
		function()
			if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
				Debug("Page3_cbDebugModeLevel3", "", 2);
				if ( Page3_cbDebugModeLevel3:GetChecked() == true ) then
					SortGroup_Variable_Page3_Options_DebugModeLevel3 = true;
					SortGroup_Variable_debuglevel = SortGroup_Variable_debuglevel + 4;
				elseif ( Page3_cbDebugModeLevel3:GetChecked() == false ) then
					SortGroup_Variable_Page3_Options_DebugModeLevel3 = false;
					SortGroup_Variable_debuglevel = SortGroup_Variable_debuglevel - 4;
				end
				SaveOptions();
				Debug("Page3_cbDebugModeLevel3", "", 1);
				SendSortOptionToSortBy(false);
			else
				ChangesComboBoxes(true);
				if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
					print(ColorPrint(L["in_combat_options"], "option"));
				end
			end
		end);
	Page3_cbDebugModeLevel3:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:AddLine(L["Page3_cbDebugModeLevel3_Option_Text"] .."\n\n" .. ColorPrint(L["Page3_cbDebugModeLevel3_Tooltip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	Page3_cbDebugModeLevel3:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
end
--ComboBox Events

local function buttonEvent()
	Debug("buttonEvent", "", 2);
	Page2_AdditionalSwitchbtnSave:SetScript("OnClick",
		function()
			Debug("Page2_AdditionalSwitchbtnSave", "", 2);
			if ( math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue()) < math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue()) ) then
				if ( SortGroup_Variable_Page2_AdditionalSwitchraidProfile ~= nil and SortGroup_Variable_Page2_AdditionalSwitchraidProfile ~= "" ) then
					if ( RaidProfilOnLoadExists(SortGroup_Variable_Page2_AdditionalSwitchraidProfile) == false ) then
						if ( ElementIsInArray( (math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())), (math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())) ) == nil ) then
							number = CountTable(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad) + 1;
							SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[number] = {}
							SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[number].RaidProfileName = SortGroup_Variable_Page2_AdditionalSwitchraidProfile;
							SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[number].Minimum = math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue());
							SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[number].Maximum =  math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue());
							UIDropDownMenu_SetText(Page2_AdditionalSwitchddmProfiles, "");
							UIDropDownMenu_SetText(Page2_AdditionalSwitchddmSavedProfiles, "");	
							Page2_AdditionalSwitchbtnDelete:Disable();
							Page2_AdditionalSwitchbtnSave:Disable();
							DisableSliders();
							fillArray();
							if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
								cache1PrintPage2_AdditionalSwitchbtnSave = L["Saved_RaidProfile_OnLoad"]:gsub("'replacement'", SortGroup_Variable_Page2_AdditionalSwitchraidProfile):gsub("'replacement2'", math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue()));
								print( ColorPrint(cache1PrintPage2_AdditionalSwitchbtnSave:gsub("'replacement3'", math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())), "option") );
							end
						else
							cache2PrintPage2_AdditionalSwitchbtnSave =  ElementIsInArray( (math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())), (math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())) );
							print( ColorPrint(L["already_in_use"]:gsub("'replacement'", cache2PrintPage2_AdditionalSwitchbtnSave), "option") );
						end
					else
						cache3PrintPage2_AdditionalSwitchbtnSave =  ElementIsInArray( (math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())), (math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())) );
						print( ColorPrint(L["already_in_use"]:gsub("'replacement'", cache3PrintPage2_AdditionalSwitchbtnSave), "option") );
					end
				elseif ( SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved ~= nil and SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved ~= "" ) then
					RaidProfilOnLoadExists(SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved);
					if ( ElementChangeOwnElement( (math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())), (math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())), SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved ) == true ) then					
						SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[SortGroup_Variable_raidProfilOnLoadIndex].RaidProfileName = SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved;
						SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[SortGroup_Variable_raidProfilOnLoadIndex].Minimum = math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue());
						SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[SortGroup_Variable_raidProfilOnLoadIndex].Maximum =  math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue());
						UIDropDownMenu_SetText(Page2_AdditionalSwitchddmProfiles, "");
						Page2_AdditionalSwitchbtnSave:Disable();
						fillArray();
						if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
							cache4PrintPage2_AdditionalSwitchbtnSave = L["Saved_RaidProfile_OnLoad"]:gsub("'replacement'", SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved):gsub("'replacement2'", math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue()));
							print( ColorPrint(cache4PrintPage2_AdditionalSwitchbtnSave:gsub("'replacement3'", math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())), "option") );
						end
					else
						print( ColorPrint(L["already_in_use"]:gsub("'replacement'", SortGroup_Variable_Page2_AdditionalSwitchraidProfilOnThatPlace), "option") );
					end
				end
				SaveOptions();
			else
				print( ColorPrint(L["Page2_AdditionalSwitchbtnSave_Error"]) );
			end
		end);
	
	Page2_AdditionalSwitchbtnDelete:SetScript("OnClick",
		function()
			Debug("Page2_AdditionalSwitchbtnDelete", "", 2);
			if ( SortGroup_Variable_raidProfilOnLoadIndex == 0 and SortGroup_Variable_Page2_AdditionalSwitchddmSavedProfilesCounter == 1 ) then
				if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
					print( ColorPrint(L["Deleted_RaidProfile"]:gsub("'replacement'", SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved), "option") );
				end
				SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad = nil;
				SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad = {};
			else
				RaidProfilOnLoadExists(SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved);
				if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
					print( ColorPrint(L["Deleted_RaidProfile"]:gsub("'replacement'", SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved), "option") );
				end
				table.remove(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad, SortGroup_Variable_raidProfilOnLoadIndex);
			end
			SortGroup_Variable_Page2_AdditionalSwitchddmSavedProfilesCounter = SortGroup_Variable_Page2_AdditionalSwitchddmSavedProfilesCounter -1;
			UIDropDownMenu_SetText(Page2_AdditionalSwitchddmSavedProfiles, "");	
			Page2_AdditionalSwitchbtnDelete:Disable();
			Page2_AdditionalSwitchbtnSave:Disable();
			DisableSliders();
			fillArray();
			SaveOptions();
		end);
		
	Page2_AdditionalSwitchbtnReset:SetScript("OnClick",
		function()
			Debug("Page2_AdditionalSwitchbtnReset", "", 2);
			SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad = nil;
			SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad = {};	
			UIDropDownMenu_SetText(Page2_AdditionalSwitchddmProfiles, "");
			UIDropDownMenu_SetText(Page2_AdditionalSwitchddmSavedProfiles, "");
			Page2_AdditionalSwitchbtnDelete:Disable();
			Page2_AdditionalSwitchbtnSave:Disable();
			DisableSliders();
			fillArray();
			SaveOptions();			
		end);
	
	Page3_OptionsbtnReload:SetScript("OnClick",
		function()
			ReloadUI();
		end);
end

local function SliderEvent()
	Debug("SliderEvent", "", 2);
	Page2_AdditionalSwitchSliderMinimum:SetScript("OnValueChanged",
		function()
			if ( (SortGroup_Variable_Page2_AdditionalSwitchraidProfile ~= nil and SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved == nil) or  (SortGroup_Variable_Page2_AdditionalSwitchraidProfile == nil and SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved ~= nil) ) then				
				ColorSliders("Minimum");
				if ( SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved ~= nil ) then
					RaidProfilOnLoadExists(SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved);
					if ( SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[SortGroup_Variable_raidProfilOnLoadIndex].Minimum ==  math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue()) and SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[SortGroup_Variable_raidProfilOnLoadIndex].Maximum ==  math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())) then
						Page2_AdditionalSwitchbtnSave:Disable();
					else
						Page2_AdditionalSwitchbtnSave:Enable();
					end
				end
			end
		end);
		
	Page2_AdditionalSwitchSliderMaximum:SetScript("OnValueChanged",
		function()
			if ( (SortGroup_Variable_Page2_AdditionalSwitchraidProfile ~= nil and SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved == nil) or  (SortGroup_Variable_Page2_AdditionalSwitchraidProfile == nil and SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved ~= nil) ) then
				ColorSliders("Maximum");
				if ( SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved ~= nil ) then
					RaidProfilOnLoadExists(SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved);
					if ( SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[SortGroup_Variable_raidProfilOnLoadIndex].Minimum ==  math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue()) and SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[SortGroup_Variable_raidProfilOnLoadIndex].Maximum ==  math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())) then
						Page2_AdditionalSwitchbtnSave:Disable();
					else
						Page2_AdditionalSwitchbtnSave:Enable();
					end
				end
			end	
		end);
end
---End Events


--[[function SortBottomDownwards()
	LoadAddOn("Blizzard_CompactRaidFrames");
	CRFSort_TopDownwards = function(t1, t2)
		local class1, classFileName1, classIndex1 = UnitClass(t1);	
		local class2, classFileName2, ClassIndex2 = UnitClass(t2);
		--print(classIndex1)
		if ( ClassIndex1 == 5 ) then
			print("Class ".. classFileName1 .. " = t1");
			return true;
		elseif ( ClassIndex2 == 5 ) then	
			print("Class ".. classFileName2 .." = t2");
			return false;
		else
			print("nothing happend with class t1: ".. classFileName1 .. " an class t2: " .. classFileName2)
			return t1 < t2;
		end
	end
	CompactRaidFrameContainer_SetFlowSortFunction(manager.container,CRFSort_TopDownwards)
	--/script UnitSetRole("player","HEALER")
	--/script print(UnitGroupRolesAssigned("player"))
end
--]]
--[[function testFunction()
	print("test")
	LoadAddOn("Blizzard_CompactRaidFrames");
	CRFSort_TopDownwards = function(t1, t2)
		if ( UnitGroupRolesAssigned(t1) == "TANK" or UnitGroupRolesAssigned(t1) == "HEALER" ) then
			return true;
		elseif ( UnitGroupRolesAssigned(t2) == "TANK" or UnitGroupRolesAssigned(t2) == "HEALER" ) then
			return false;
		else
			return t1 > t2;
		end
	end
	CompactRaidFrameContainer_SetFlowSortFunction(manager.container,CRFSort_TopDownwards)
	--/script UnitSetRole("player","HEALER")
	--/script print(UnitGroupRolesAssigned("player"))
end
--]]
-- Some tries to sort by class. Does actually work but needs further messures to get implemented

function SortTopDownwards()
	Debug("SortTopDownwards", "", 2);
	LoadAddOn("Blizzard_CompactRaidFrames");
	CRFSort_TopDownwards = function(t1, t2)
		if UnitIsUnit(t1, "player") then 
			return true;
		elseif UnitIsUnit(t2, "player") then 
			return false;
		else 
			return t1 < t2;
		end 
	end
	CompactRaidFrameContainer_SetFlowSortFunction(manager.container,CRFSort_TopDownwards)
end

function SortTopUpwards()
	Debug("SortTopUpwards", "", 2);
	LoadAddOn("Blizzard_CompactRaidFrames");
	CRFSort_TopUpwards = function(t1, t2)
		if UnitIsUnit(t1, "player") then 
			return true;
		elseif UnitIsUnit(t2, "player") then 
			return false;
		else 
			return t1 > t2;
		end 
	end
	CompactRaidFrameContainer_SetFlowSortFunction(manager.container,CRFSort_TopUpwards)
end
	
function SortBottomUpwards()
	Debug("SortBottomUpwards", "", 2);
	LoadAddOn("Blizzard_CompactRaidFrames");
	CRFSort_BottomUpwards = function(t1, t2)
		if UnitIsUnit(t1, "player") then 
			return false;
		elseif UnitIsUnit(t2, "player") then 
			return true; 
		else 
			return t1 > t2;
		end 
	end
	CompactRaidFrameContainer_SetFlowSortFunction(manager.container,CRFSort_BottomUpwards)
end

function SortBottomDownwards()
	Debug("SortBottomDownwards", "", 2);
	LoadAddOn("Blizzard_CompactRaidFrames");
	CRFSort_BottomDownwards = function(t1, t2)
		if UnitIsUnit(t1, "player") then 
			return false;
		elseif UnitIsUnit(t2, "player") then 
			return true; 
		else 
			return t1 < t2;
		end 
	end
	CompactRaidFrameContainer_SetFlowSortFunction(manager.container,CRFSort_BottomDownwards)
end

function SendSortOptionToSortBy(ExternSwitch)
	Debug("SendSortOptionToSortBy", "", 2);
	if ( SortGroup_Variable_RegardlessRaidProfile == false ) then
		if ( SortGroup_Variable_GroupTop == true or SortGroup_Variable_GroupBottom == true ) then
			if ( ReadAllRaidProfiles(SortGroup_Variable_raidProfile) == false ) then
				cachePrintSendSortOptionToSortBy = L["RaidProfil_dont_exists"]:gsub("'replacement'", SortGroup_Variable_raidProfile);
				SortGroup_Variable_raidProfile = GetRaidProfileName(1);
				if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
					print(ColorPrint(cachePrintSendSortOptionToSortBy:gsub("'replacement2'", SortGroup_Variable_raidProfile), "option"));
				end
				UIDropDownMenu_SetText(ddmProfiles, SortGroup_Variable_raidProfile);
			end
		end
	end
	if ( SortGroup_Variable_GroupTop == true ) then
		SortBy('Down', SortGroup_Variable_raidProfile, ExternSwitch);
	elseif ( SortGroup_Variable_GroupBottom == true ) then
		SortBy('Up', SortGroup_Variable_raidProfile, ExternSwitch);
	else
		if ( SortGroup_Variable_showChatMessage == true ) then
			if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
				print (ColorPrint(L["sort_no"], "option"));
			end	
		end
	end
	if ( SortGroup_Variable_showChatMessage == true ) then
		SortGroup_Variable_showChatMessage = false;
	end
end
-- Breakpoint between Methods and SortBy

function SortBy(SortOption, RaidProfileName, ExternSwitch)	
	Debug("SortBy", "", 2);
	if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
		if ( RaidProfileName ~= nil and GetNumGroupMembers() <= 5 and HasLoadedCUFProfiles() == true ) then
			if ( SortGroup_Variable_GroupAutoActivate == true or SortGroup_Variable_Page2_AdditionalSwitchActive == true ) then
				if ( ExternSwitch == false ) then
					SwitchRaidProfiles();
				end
			end
			if ( GetActiveRaidProfile() ~= RaidProfileName and SortGroup_Variable_GroupAutoActivate == false and SortGroup_Variable_RegardlessRaidProfile == false ) then
				if ( SortGroup_Variable_showChatMessage == true ) then
					if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
						print(ColorPrint(L["RaidProfil_Doesnt_match"], "option"));
					end
				end
			elseif ( GetActiveRaidProfile() == RaidProfileName or SortGroup_Variable_RegardlessRaidProfile == true ) then
				if ( SortOption == 'Down') then
					if ( SortGroup_Variable_GroupTopDownwards == true ) then
						if ( SortGroup_Variable_showChatMessage == true ) then
							if ( SortGroup_Variable_RegardlessRaidProfile == true ) then
								if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
									print(ColorPrint(L["sort_top_downwards_regardless"], "option"));
								end
							else
								if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
									print(ColorPrint(L["sort_top_downwards"]:gsub("'replacement'", RaidProfileName), "option"));
								end
							end
						end
						CheckRaidProfileOptions();
						SortTopDownwards();
					end
					if ( SortGroup_Variable_GroupTopUpwards == true ) then
						if ( SortGroup_Variable_showChatMessage == true ) then
							if ( SortGroup_Variable_RegardlessRaidProfile == true ) then
								if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
									print(ColorPrint(L["sort_top_upwards_regardless"], "option"));
								end
							else
								if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
									print(ColorPrint(L["sort_top_upwards"]:gsub("'replacement'", RaidProfileName), "option"));
								end
							end
						end
						CheckRaidProfileOptions();
						SortTopUpwards();
					end
				elseif ( SortOption == 'Up') then
					if ( SortGroup_Variable_GroupBottomDownwards == true ) then
						if ( SortGroup_Variable_showChatMessage == true ) then
							if ( SortGroup_Variable_RegardlessRaidProfile == true ) then
								if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
									print(ColorPrint(L["sort_bottom_downwards_regardless"], "option"));
								end
							else
								if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
									print(ColorPrint(L["sort_bottom_downwards"]:gsub("'replacement'", RaidProfileName), "option"));
								end
							end
						end
						CheckRaidProfileOptions();
						SortBottomDownwards();
					end
					if ( SortGroup_Variable_GroupBottomUpwards == true ) then
						if ( SortGroup_Variable_showChatMessage == true ) then
							if ( SortGroup_Variable_RegardlessRaidProfile == true ) then
								if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
									print(ColorPrint(L["sort_bottom_upwards_regardless"], "option"));
								end
							else
								if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
									print(ColorPrint(L["sort_bottom_upwards"]:gsub("'replacement'", RaidProfileName), "option"));
								end
							end
						end
						CheckRaidProfileOptions();
						SortBottomUpwards();
					end
				end
			end		
		end
	end
end
-- Final desicion, which Raid Profile gets loaded and which Sort Method will be used

function CheckRaidProfileOptions()
	Debug("CheckRaidProfileOptions", "RaidStylePartyFrames clicked", 2);
	if ( GetNumGroupMembers() <= 5 ) then
		if ( CompactUnitFrameProfilesRaidStylePartyFrames:GetChecked() == false ) then
			CompactUnitFrameProfilesRaidStylePartyFrames:Click("LeftButton",true);
			Debug("CheckRaidProfileOptions", "RaidStylePartyFrames clicked", 3);
		end
		if ( CompactUnitFrameProfilesGeneralOptionsFrameKeepGroupsTogether:GetChecked() == true ) then
			--CompactUnitFrameProfilesGeneralOptionsFrameKeepGroupsTogether:Click();
			if ( SortGroup_Variable_showChatMessage == true and SortGroup_Variable_Page3_chatMessagesOn == true ) then
				print(ColorPrint(L["Keep_Group_Together_Active"], "option"));
			end
			Debug("CheckRaidProfileOptions", "KeepGroupsTogether checked", 3);
		end
	end
end
--necessary changes, otherwise there is no sort
--CompactUnitFrameProfilesGeneralOptionsFrameKeepGroupsTogether taints, so User needs to do this one

function ReadAllRaidProfiles(SortGroup_Variable_raidProfile)
	Debug("ReadAllRaidProfiles", "", 2);
	raidprofilexists = false;
	SortGroup_Variable_ddmItems = nil;
	SortGroup_Variable_ddmItems = {};
	for i=1, GetNumRaidProfiles(), 1 do
		SortGroup_Variable_ddmItems[i] = GetRaidProfileName(i);
		if ( SortGroup_Variable_ddmItems[i] == SortGroup_Variable_raidProfile ) then
			raidprofilexists = true;
			
		end
	end
	if ( raidprofilexists == true ) then
		Debug("ReadAllRaidProfiles", SortGroup_Variable_raidProfile .. " exists", 3);
		return true;
	end
	return false;
end
--Fills SortGroup_Variable_ddmItems with raidprofiles and checks if raidprofil exists

function ChangesComboBoxes()
	Debug("ChangesComboBoxes", "", 2);
	if ( SortGroup_Variable_GroupAutoActivate == true ) then
		cbAutoActivate:SetChecked(true);
		getglobal(cbAutoActivate:GetName() .. 'Text'):SetText(ColorPrint(L["cbAutoActivate_Option_Text"],"white"));
	else
		cbAutoActivate:SetChecked(false);
	end
	
	if ( SortGroup_Variable_RegardlessRaidProfile == true ) then
		SortGroup_Variable_cacheAutoActive = AutoActivate;
		AutoActivate = false;
		UIDropDownMenu_DisableDropDown(ddmProfiles);
		cbAutoActivate:Disable();
		getglobal(cbAutoActivate:GetName() .. 'Text'):SetText(ColorPrint(L["cbAutoActivate_Option_Text"],"disable"));
		cbRegardlessRaidProfile:SetChecked(true);
	else
		SortGroup_Variable_RegardlessRaidProfile = false;
		AutoActivate = SortGroup_Variable_cacheAutoActive;
		cbAutoActivate:Enable();
		if ( cbAutoActivate:GetChecked() == true ) then
			UIDropDownMenu_EnableDropDown(ddmProfiles);
		end
		cbRegardlessRaidProfile:SetChecked(false);
	end
	
	if ( SortGroup_Variable_GroupTop == true ) then
		cBTop:SetChecked(true);
		cBBottom:SetChecked(false);
		cbTopDownwards:Enable();
		cbTopUpwards:Enable();
		cbBottomDownwards:Disable();
		cbBottomUpwards:Disable();
		getglobal(cbTopDownwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbDownwards_Option_Text"], "white"));
		getglobal(cbTopUpwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbUpwards_Option_Text"], "white"));
		getglobal(cbBottomDownwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbDownwards_Option_Text"],"disable"));
		getglobal(cbBottomUpwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbUpwards_Option_Text"],"disable"));
	elseif ( SortGroup_Variable_GroupBottom == true ) then
		cBTop:SetChecked(false);
		cBBottom:SetChecked(true);
		cbTopDownwards:Disable();
		cbTopUpwards:Disable();
		cbBottomDownwards:Enable();
		cbBottomUpwards:Enable();
		getglobal(cbTopDownwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbDownwards_Option_Text"],"disable"));
		getglobal(cbTopUpwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbUpwards_Option_Text"],"disable"));
		getglobal(cbBottomDownwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbDownwards_Option_Text"], "white"));
		getglobal(cbBottomUpwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbUpwards_Option_Text"], "white"));
	else
		cBTop:SetChecked(false);
		cBBottom:SetChecked(false);
		cbTopDownwards:Disable();
		cbTopUpwards:Disable();
		cbBottomDownwards:Disable();
		cbBottomUpwards:Disable();
		getglobal(cbTopDownwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbDownwards_Option_Text"],"disable"));
		getglobal(cbTopUpwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbUpwards_Option_Text"],"disable"));
		getglobal(cbBottomDownwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbDownwards_Option_Text"],"disable"));
		getglobal(cbBottomUpwards:GetName() .. 'Text'):SetText(ColorPrint(L["cbUpwards_Option_Text"],"disable"));
	end
	
	if ( SortGroup_Variable_GroupTopDownwards == true ) then
		cbTopDownwards:SetChecked(true);
		cbTopUpwards:SetChecked(false);
	elseif ( SortGroup_Variable_GroupTopUpwards == true ) then
			cbTopDownwards:SetChecked(false);
			cbTopUpwards:SetChecked(true);
	else 	
		cbTopDownwards:SetChecked(false);
		cbTopUpwards:SetChecked(false);
	end
	if ( SortGroup_Variable_GroupBottomDownwards == true ) then
		cbBottomDownwards:SetChecked(true);
		cbBottomUpwards:SetChecked(false);
	elseif ( SortGroup_Variable_GroupBottomUpwards == true ) then
		cbBottomDownwards:SetChecked(false);
		cbBottomUpwards:SetChecked(true);
	else
		cbBottomDownwards:SetChecked(false);
		cbBottomUpwards:SetChecked(false);
	end
	
	if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
		Page3_cbChatMessagesOn:SetChecked(true);
	else 
		Page3_cbChatMessagesOn:SetChecked(false);
	end
	
	if ( SortGroup_Variable_Page2_AdditionalSwitchActive == true ) then
		Page2_AdditionalSwitchcbActive:SetChecked(true);
		UIDropDownMenu_EnableDropDown(Page2_AdditionalSwitchddmProfiles);
	else
		UIDropDownMenu_SetText(Page2_AdditionalSwitchddmProfiles, "");
		Page2_AdditionalSwitchcbActive:SetChecked(false);
		UIDropDownMenu_DisableDropDown(Page2_AdditionalSwitchddmProfiles);
		DisableSliders();
	end
	if ( SortGroup_Variable_Page2_AdditionalSwitchraidProfile == nil ) then
		DisableSliders();
	end
	if ( SortGroup_Variable_Page3_ChangesInCombat == true ) then
		Page3_cbChangesInCombat:SetChecked(true);
	else
		Page3_cbChangesInCombat:SetChecked(false);
	end
	if ( SortGroup_Variable_Page3_RaidProfilesUpdateInCombat == true ) then
		Page3_cbRaidProfilesUpdateInCombat:SetChecked(true);
	else
		Page3_cbRaidProfilesUpdateInCombat:SetChecked(false);
	end
	if ( SortGroup_Variable_Page3_Options_DebugMode == false ) then
		Page3_cbDebugMode:SetChecked(false);
		Page3_cbDebugModeLevel1:Disable();
		Page3_cbDebugModeLevel2:Disable();
		Page3_cbDebugModeLevel3:Disable();
		getglobal(Page3_cbDebugModeLevel1:GetName() .. 'Text'):SetText(ColorPrint(L["Page3_cbDebugModeLevel1_Option_Text"],"disable"));
		getglobal(Page3_cbDebugModeLevel2:GetName() .. 'Text'):SetText(ColorPrint(L["Page3_cbDebugModeLevel2_Option_Text"],"disable"));
		getglobal(Page3_cbDebugModeLevel3:GetName() .. 'Text'):SetText(ColorPrint(L["Page3_cbDebugModeLevel3_Option_Text"],"disable"));
		SortGroup_Variable_debuglevel = 0;
	else
		Page3_cbDebugMode:SetChecked(true);
		Page3_cbDebugModeLevel1:Enable();
		Page3_cbDebugModeLevel2:Enable();
		Page3_cbDebugModeLevel3:Enable();
		getglobal(Page3_cbDebugModeLevel1:GetName() .. 'Text'):SetText(ColorPrint(L["Page3_cbDebugModeLevel1_Option_Text"], "white"));
		getglobal(Page3_cbDebugModeLevel2:GetName() .. 'Text'):SetText(ColorPrint(L["Page3_cbDebugModeLevel2_Option_Text"], "white"));
		getglobal(Page3_cbDebugModeLevel3:GetName() .. 'Text'):SetText(ColorPrint(L["Page3_cbDebugModeLevel3_Option_Text"], "white"));
		SortGroup_Variable_debuglevel = 0;
		if( SortGroup_Variable_Page3_Options_DebugModeLevel1 == true ) then
			Page3_cbDebugModeLevel1:SetChecked(true);
			SortGroup_Variable_debuglevel = SortGroup_Variable_debuglevel + 1;	
		end
		if( SortGroup_Variable_Page3_Options_DebugModeLevel2 == true ) then
			Page3_cbDebugModeLevel2:SetChecked(true);
			SortGroup_Variable_debuglevel = SortGroup_Variable_debuglevel + 2;
		end
		if( SortGroup_Variable_Page3_Options_DebugModeLevel3 == true ) then
			Page3_cbDebugModeLevel3:SetChecked(true);
			SortGroup_Variable_debuglevel = SortGroup_Variable_debuglevel + 4;
		end
	end
	if( SortGroup_Variable_Page3_Options_DebugModeLevel1 == true ) then
		Page3_cbDebugModeLevel1:SetChecked(true);
	else
		Page3_cbDebugModeLevel1:SetChecked(false);
	end
	if( SortGroup_Variable_Page3_Options_DebugModeLevel2 == true ) then
		Page3_cbDebugModeLevel2:SetChecked(true);
	else
		Page3_cbDebugModeLevel2:SetChecked(false);
	end
	if( SortGroup_Variable_Page3_Options_DebugModeLevel3 == true ) then
		Page3_cbDebugModeLevel3:SetChecked(true);
	else
		Page3_cbDebugModeLevel3:SetChecked(false);
	end
end
--In combat no changes

function DisableSliders()
	Debug("DisableSliders", "", 2);
	Page2_AdditionalSwitchSliderMinimum:Disable();
	Page2_AdditionalSwitchSliderMaximum:Disable();
	Page2_AdditionalSwitchbtnSave:Disable();
	Page2_AdditionalSwitchbtnDelete:Disable();
	getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Low'):SetText(ColorPrint('2', "disable"));
	getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'High'):SetText(ColorPrint('40', "disable"));
	getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Text'):SetText(ColorPrint(math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue()), "disable"));
	getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Low'):SetText(ColorPrint('2', "disable"));
	getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'High'):SetText(ColorPrint('40', "disable"))
	getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Text'):SetText(ColorPrint(math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue()), "disable"));
end

function ColorSliders(option,index)
	Debug("ColorSliders", "", 2);
	cacheProfileColorSliders = nil
	if ( SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved ~= nil ) then
		cacheProfileColorSliders = SortGroup_Variable_Page2_AdditionalSwitchraidProfileSaved;
	else
		cacheProfileColorSliders = SortGroup_Variable_Page2_AdditionalSwitchraidProfile;
	end
	if ( option == "Minimum" ) then
		if ( ( math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue()) ) < ( math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue()) ) ) then
			if ( MinMaxInArray(math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())) == false ) then
				getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())), "green" ));
			elseif ( ElementChangeOwnElement( (math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())), (math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())), cacheProfileColorSliders ) == true ) then
				getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())), "green" ));
			else
				getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())), "red" ));
			end
		else
			Page2_AdditionalSwitchSliderMinimum:SetValue(math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue()) -1 );
			if ( MinMaxInArray(math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())) == false ) then
				getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())  ), "green" ));
			elseif ( ElementChangeOwnElement( (math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())), (math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())), cacheProfileColorSliders ) == true ) then				
				getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue()) ), "green" ));
			else
				getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())  ), "red" ));
			end
		end
	elseif ( option == "Maximum" ) then
		if ( ( math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue()) ) > ( math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue()) ) ) then
			if ( MinMaxInArray(math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())) == false ) then
				getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())), "green" ));
			elseif ( ElementChangeOwnElement( (math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())), (math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())), cacheProfileColorSliders ) == true ) then
				getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())), "green" ));
			else
				getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())), "red" ));
			end
		else
			Page2_AdditionalSwitchSliderMaximum:SetValue(math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue()) +1 );
			if ( MinMaxInArray(math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())) == false ) then
				getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue()) ), "green" ));
			elseif ( ElementChangeOwnElement( (math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())), (math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())), cacheProfileColorSliders ) == true ) then
				getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue()) ), "green" ));
			else
				getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue()) ), "red" ));
			end
		end
	elseif ( option == "ddmProfiles" ) then
		if ( MinMaxInArray(math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())) == false ) then
			getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())), "green" ));
		else
			getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(Page2_AdditionalSwitchSliderMinimum:GetValue())), "red" ));
		end
		if ( MinMaxInArray(math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())) == false ) then
			getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())), "green" ));
		else
			getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Text'):SetText( ColorPrint((math.floor(Page2_AdditionalSwitchSliderMaximum:GetValue())), "red" ));
		end
	elseif ( option == "ddmSelectedProfiles" ) then
		Page2_AdditionalSwitchSliderMinimum_Text:SetValue( SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[index].Minimum );
		Page2_AdditionalSwitchSliderMaximum_Text:SetValue( SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[index].Maximum );
		getglobal(Page2_AdditionalSwitchSliderMinimum:GetName() .. 'Text'):SetText( ColorPrint(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[index].Minimum, "green" ));
		getglobal(Page2_AdditionalSwitchSliderMaximum:GetName() .. 'Text'):SetText( ColorPrint(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[index].Maximum, "green" ));
	end
end
-- Method to only coler sliders
	
function resetRaidContainer()	
	if ( SortGroup_Variable_Page3_RaidProfilesUpdateInCombat == false ) then
		Debug("resetRaidContainer", "", 2);
		local old_CompactRaidFrameContainer_TryUpdate = CompactRaidFrameContainer_TryUpdate
		CompactRaidFrameContainer_TryUpdate = function(self)	
			if ( SortGroup_Variable_inCombat == true ) then
				SortGroup_Variable_CompactSave[self:GetName()] = "CompactRaidFrameContainer_TryUpdate"
			else
				old_CompactRaidFrameContainer_TryUpdate(self)
			end
		end

		local old_CompactRaidGroup_UpdateUnits = CompactRaidGroup_UpdateUnits
		CompactRaidGroup_UpdateUnits = function(self)
			if ( SortGroup_Variable_inCombat == true ) then
				SortGroup_Variable_CompactSave[self:GetName()] = "CompactRaidGroup_UpdateUnits"
			else
				old_CompactRaidGroup_UpdateUnits(self)
			end
		end
	end
end

function ProfileChanged()
	Debug("ProfileChanged", "", 2);
	hooksecurefunc("CompactUnitFrameProfiles_ActivateRaidProfile", function(profile)
		if ( SortGroup_Variable_RegardlessRaidProfile == true or ( SortGroup_Variable_RegardlessRaidProfile == false and SortGroup_Variable_GroupAutoActivate == false and GetActiveRaidProfile() == SortGroup_Variable_raidProfile )) then
			Debug("ProfileChanged", "true", 3);
			SendSortOptionToSortBy(true);
		else
			Debug("ProfileChanged", "false", 3);
		end
	end);
end

function SortGroupIsActive()
	Debug("SortGroupIsActive", "", 2);
	if ( GetNumGroupMembers() <= 5 and ( (SortGroup_Variable_GroupTop == true and SortGroup_Variable_GroupTopDownwards == true) or (SortGroup_Variable_GroupTop == true and SortGroup_Variable_GroupTopUpwards == true) or (SortGroup_Variable_GroupBottom == true and SortGroup_Variable_GroupBottomDownwards == true) or (GrouUp == true and SortGroup_Variable_GroupBottomUpwards == true) ) ) then
		Debug("SortGroupIsActive", true, 3);
		return true;
	end
	Debug("SortGroupIsActive", false, 3);
	return false;
end
-- Triggered by every party member change

function ColorPrint(text, operation)
	if ( operation == "option" ) then
		cacheText = text:gsub("SortGroup:" , function(cap)
			cap = cap:sub(1, -1);
			local color = "|cff00FF7F" or defaultColor;
			return color..cap.."|r";
		end)
		return cacheText;
	elseif ( operation == "disable" ) then
		local color = "|cff888888" or defaultColor;
		return color..text;
	elseif ( operation == "green" ) then
		local color = "|cff00ff00" or defaultColor;
		return color..text;
	elseif ( operation == "red" ) then
		local color = "|cffff0000" or defaultColor;
		return color..text;
	elseif ( operation == "white" ) then
		local color = "|cffffffff" or defaultColor;
		return color..text;
	end
end
-- Color everything expcept sliders

function CountTable(t)
	Debug("CountTable", "", 2);
	local count = 0
	for _ in pairs(t) do count = count + 1 end
	return count;
end

function RaidProfilOnLoadExists(raidProfilOnLoad)
	Debug("RaidProfilOnLoadExists", nil, 2);
	if ( CountTable(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad) > 0 ) then
		for i = 1, (CountTable(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad)), 1 do
			if ( SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i] ~= nil ) then
				if ( SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].RaidProfileName == raidProfilOnLoad ) then
					SortGroup_Variable_raidProfilOnLoadIndex = i;
					Debug("RaidProfilOnLoadExists", true);
					return true;
				end
			else
				Debug("RaidProfilOnLoadExists", nil, 3);
			end
		end
	end
	return false;
end
--  Checks if RaidProfil is in List

function DeleteRaidProfileNotExists()
	Debug("DeleteRaidProfileNotExists", "", 2);
	if ( CountTable(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad) > 0 ) then
		for i = 1, (CountTable(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad)), 1 do
			if ( SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i] ~= nil ) then
				if ( ReadAllRaidProfiles(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].RaidProfileName) == false ) then
					if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
						print( ColorPrint(L["Deleted_RaidProfile_Not_Exists"]:gsub("'replacement'", (SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].RaidProfileName)), "option") );
					end
					Debug("DeleteRaidProfileNotExists", (SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].RaidProfileName .. " deleted"), 3 );
					table.remove(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad, i);	
					Page2_AdditionalSwitchbtnDelete:Disable();
					Page2_AdditionalSwitchbtnSave:Disable();
					DisableSliders();
				end
			end
		end
	end
	fillArray();
end
-- Raid Profiles that not exists anymore get deleted

function SwitchRaidProfiles()
	Debug("SwitchRaidProfiles", "", 2);
	if ( SortGroup_Variable_inCombat == false or SortGroup_Variable_Page3_ChangesInCombat == true ) then
		DeleteRaidProfileNotExists();
		member = tonumber(GetNumGroupMembers());
		if ( HasLoadedCUFProfiles() == true and GetNumGroupMembers() > 0 ) then
			if ( SortGroup_Variable_Page2_AdditionalSwitchArray[member][0] == true and SortGroup_Variable_Page2_AdditionalSwitchArray[member][1] ~= "" ) then
				if ( GetActiveRaidProfile() ~= SortGroup_Variable_Page2_AdditionalSwitchArray[member][1] and SortGroup_Variable_Page2_AdditionalSwitchActive == true ) then	
					ExecuteSwitchRaidProfiles(SortGroup_Variable_Page2_AdditionalSwitchArray[member][1]);
					if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
						print( ColorPrint(L["RaidProfil_changed"]:gsub("'replacement'", (SortGroup_Variable_Page2_AdditionalSwitchArray[member][1])), "option") );
					end
					Debug("SwitchRaidProfiles", "member > 0, SortGroup_Variable_Page2_AdditionalSwitchActive = true", 3);
				elseif ( GetActiveRaidProfile() ~= SortGroup_Variable_Page2_AdditionalSwitchArray[member][1] and SortGroup_Variable_Page2_AdditionalSwitchActive == false ) then
					if ( SortGroup_Variable_Page2_AdditionalSwitchArray[1][0] == true and SortGroup_Variable_Page2_AdditionalSwitchArray[1][1] ~= "" ) then
						if ( GetActiveRaidProfile() ~= SortGroup_Variable_Page2_AdditionalSwitchArray[1][1] ) then
							ExecuteSwitchRaidProfiles(SortGroup_Variable_Page2_AdditionalSwitchArray[1][1]);
						end
						if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
							print( ColorPrint(L["RaidProfil_changed"]:gsub("'replacement'", (SortGroup_Variable_Page2_AdditionalSwitchArray[1][1])), "option") );
						end
					Debug("SwitchRaidProfiles", "member > 0, SortGroup_Variable_Page2_AdditionalSwitchActive = false", 3);
					end
				end	
			end
		elseif ( HasLoadedCUFProfiles() == true and member == 0 ) then
			if ( SortGroup_Variable_Page2_AdditionalSwitchArray[1][0] == true and SortGroup_Variable_Page2_AdditionalSwitchArray[1][1] ~= "" ) then
				if ( GetActiveRaidProfile() ~= SortGroup_Variable_Page2_AdditionalSwitchArray[1][1] ) then
					ExecuteSwitchRaidProfiles(SortGroup_Variable_Page2_AdditionalSwitchArray[1][1]);
					if ( SortGroup_Variable_Page3_chatMessagesOn == true ) then
						print( ColorPrint(L["RaidProfil_changed"]:gsub("'replacement'", (SortGroup_Variable_Page2_AdditionalSwitchArray[1][1])), "option") );
					end
					Debug("SwitchRaidProfiles", "member = 0", 3);
				end
			end
		end
	end
end
-- Switch by Group_Roster

function ExecuteSwitchRaidProfiles(profile)
	Debug("ExecuteSwitchRaidProfiles", "", 2);
	Debug("ExecuteSwitchRaidProfiles", "with profile: profile", 3);
	CompactUnitFrameProfiles.selectedProfile = profile;
	SaveRaidProfileCopy(profile);
	SetCVar("activeCUFProfile", profile);
	UIDropDownMenu_SetSelectedValue(CompactUnitFrameProfilesProfileSelector, profile);
	UIDropDownMenu_SetText(CompactUnitFrameProfilesProfileSelector, profile);	
	UIDropDownMenu_SetSelectedValue(CompactRaidFrameManagerDisplayFrameProfileSelector, profile);
	UIDropDownMenu_SetText(CompactRaidFrameManagerDisplayFrameProfileSelector, profile);		
	CompactUnitFrameProfiles_ApplyCurrentSettings();
	--CompactUnitFrameProfiles_UpdateCurrentPanel();
	--Taint - Disabled
	CompactUnitFrameProfiles_HidePopups();
end

function fillArray()
	Debug("fillArray", "", 2);
	for i = 1, 40, 1 do
		SortGroup_Variable_Page2_AdditionalSwitchArray[i] = {};
		if ( SortGroup_Variable_GroupAutoActivate == true and SortGroup_Variable_RegardlessRaidProfile == false and i <= 5 ) then
			SortGroup_Variable_Page2_AdditionalSwitchArray[i][0] = true;
			SortGroup_Variable_Page2_AdditionalSwitchArray[i][1] = SortGroup_Variable_raidProfile;
		else
			SortGroup_Variable_Page2_AdditionalSwitchArray[i][0] = false;
			SortGroup_Variable_Page2_AdditionalSwitchArray[i][1] = "";
		end
	end
	if ( CountTable(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad) > 0 ) then
		for i = 1, (CountTable(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad)), 1 do
			for c = (tonumber(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].Minimum)), (tonumber(SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].Maximum)), 1 do
				if ( (SortGroup_Variable_GroupAutoActivate == true and c > 5) or SortGroup_Variable_GroupAutoActivate == false ) then
					if ( SortGroup_Variable_Page2_AdditionalSwitchArray[c] ~= nil ) then
						SortGroup_Variable_Page2_AdditionalSwitchArray[c][0] = true;
						SortGroup_Variable_Page2_AdditionalSwitchArray[c][1] = SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].RaidProfileName;
					elseif ( SortGroup_Variable_Page2_AdditionalSwitchArray[c] == nil ) then
						Debug("fillArray", nil, 3);
					end
					if ( SortGroup_Variable_Page2_AdditionalSwitchArray[c][0] == true ) then
						Debug("fillArray", ("Index " .. c .. " true"), 3);
					else
						Debug("fillArray", ("Index " .. c .. " false"), 3);
					end
				elseif ( SortGroup_Variable_GroupAutoActivate == true and c <= 5 ) then
					SortGroup_Variable_Page2_AdditionalSwitchArray[c][0] = true;
					SortGroup_Variable_Page2_AdditionalSwitchArray[c][1] = SortGroup_Variable_raidProfile;
					if ( SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].Minimum <= 5 ) then
					Debug("fillArray", ("RaidProfil: " .. SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].RaidProfileName .. " Minimum: " .. SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].Minimum .. " deleted"), 3);
						SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].Minimum = 6;
					end
					if ( SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].Maximum <= 6 ) then
						Debug("fillArray", ("RaidProfil: " .. SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].RaidProfileName .. "Maximum: " .. SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].Maximum .. " deleted"), 3);
						SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad[i].Maximum = 7; 
					end
				end
			end
		end
	end
end
-- Update Array with updated RaidProfil List

function ElementIsInArray(Minimum, Maximum)
	Debug("ElementIsInArray","", 2)
	for i = (tonumber(Minimum)), (tonumber(Maximum)), 1 do
		if ( SortGroup_Variable_Page2_AdditionalSwitchArray[i] ~= nil ) then	
			if ( SortGroup_Variable_Page2_AdditionalSwitchArray[i][0] == true ) then
				Debug("ElementIsInArray", ("Index " .. i .. " SortGroup_Variable_Page2_AdditionalSwitchArray[i][1]"));
				return SortGroup_Variable_Page2_AdditionalSwitchArray[i][1];
			end
		else
			Debug("ElementIsInArray",nil, 3)
		end
	end
	return nil;
end
-- Checks if no Raid Profils are in a specific Group Size

function MinMaxInArray(MinMax)
	Debug("MinMaxInArray", "", 2);
	if ( SortGroup_Variable_Page2_AdditionalSwitchArray[MinMax] ~= nil ) then
		if ( SortGroup_Variable_Page2_AdditionalSwitchArray[MinMax][0] == true ) then
			Debug("MinMaxInArray", true, 3);
			return true;
		else
			Debug("MinMaxInArray", false, 3);
			return false;
		end
	end
end
--Minimum Maximum check, true if exists

function ElementChangeOwnElement(Minimum, Maximum, raidProfilOnLoad)
	Debug("ElementChangeOwnElement", "", 2)
	OwnElement = true;
	for i = (tonumber(Minimum)), (tonumber(Maximum)), 1 do
		if ( SortGroup_Variable_Page2_AdditionalSwitchArray[i] ~= nil ) then
			if ( SortGroup_Variable_Page2_AdditionalSwitchArray[i][0] == true ) then
				if ( SortGroup_Variable_Page2_AdditionalSwitchArray[i][1] ~= raidProfilOnLoad ) then
					SortGroup_Variable_Page2_AdditionalSwitchraidProfilOnThatPlace = SortGroup_Variable_Page2_AdditionalSwitchArray[i][1];
					OwnElement = false;
				end
			end
		else
			OwnElement = nil;
		end
	end
	Debug("ElementChangeOwnElement", OwnElement, 3)
	return OwnElement;
end
-- true if Raid Profil change only itselfs options


function SaveOptions()
	Debug("SaveOptions", "", 2);
	SortGroupInformation.Down = SortGroup_Variable_GroupTop;
	SortGroupInformation.Up = SortGroup_Variable_GroupBottom;
	SortGroupInformation.TopDownwards = SortGroup_Variable_GroupTopDownwards;
	SortGroupInformation.TopUpwards	= SortGroup_Variable_GroupTopUpwards;
	SortGroupInformation.BottomDownwards = SortGroup_Variable_GroupBottomDownwards;
	SortGroupInformation.BottomUpwards = SortGroup_Variable_GroupBottomUpwards;
	SortGroupInformation.Profile = SortGroup_Variable_raidProfile;
	SortGroupInformation.AutoActivate = SortGroup_Variable_GroupAutoActivate;
	SortGroupInformation.SortGroup_Variable_RegardlessRaidProfile = SortGroup_Variable_RegardlessRaidProfile;
	SortGroupInformation.SortGroup_Variable_Page3_chatMessagesOn = SortGroup_Variable_Page3_chatMessagesOn;
	SortGroupInformation.SortGroup_Variable_Page2_AdditionalSwitchActive = SortGroup_Variable_Page2_AdditionalSwitchActive;
	SortGroupInformation.RaidProfileOnLoad = SortGroup_Variable_Page2_AdditionalSwitchRaidProfilesOnLoad;
	SortGroupInformation.SortGroup_Variable_Page3_ChangesInCombat = SortGroup_Variable_Page3_ChangesInCombat;
	SortGroupInformation.SortGroup_Variable_Page3_RaidProfilesUpdateInCombat = SortGroup_Variable_Page3_RaidProfilesUpdateInCombat;
	SortGroupInformation.SortGroup_Variable_Page3_Options_DebugMode = SortGroup_Variable_Page3_Options_DebugMode;
	SortGroupInformation.SortGroup_Variable_Page3_Options_DebugModeLevel1 = SortGroup_Variable_Page3_Options_DebugModeLevel1;
	SortGroupInformation.SortGroup_Variable_Page3_Options_DebugModeLevel2 = SortGroup_Variable_Page3_Options_DebugModeLevel2;
	SortGroupInformation.SortGroup_Variable_Page3_Options_DebugModeLevel3 = SortGroup_Variable_Page3_Options_DebugModeLevel3;
end
-- If client crashes, still all saved

function Debug(methodName, methodContent, methodLevel)
	if ( SortGroup_Variable_Page3_Options_DebugMode == true ) then
	SortGroup_Variable_debugLevelCache = SortGroup_Variable_debuglevel;
		if ( SortGroup_Variable_debugLevelCache % 2 == 1 and methodLevel >= 1 ) then
			SortGroup_Variable_debugLevelCache = SortGroup_Variable_debugLevelCache - 1;
			if ( methodLevel == 1 ) then
				SortGroup_Variable_debugMethodNamePrint = true;
				print(ColorPrint("SortGroup: Debuging - Options", "option"));
				print("'SortGroup_Variable_GroupTop' " .. tostring(SortGroup_Variable_GroupTop));
				print("'SortGroup_Variable_GroupTopDownwards' " .. tostring(SortGroup_Variable_GroupTopDownwards));
				print("'SortGroup_Variable_GroupTopUpwards' " .. tostring(SortGroup_Variable_GroupTopUpwards));
				print("'SortGroup_Variable_GroupBottom' " .. tostring(SortGroup_Variable_GroupBottom));
				print("'SortGroup_Variable_GroupBottomDownwards' " .. tostring(SortGroup_Variable_GroupBottomDownwards));
				print("'Profile' " .. tostring(SortGroup_Variable_raidProfile));
				print("'SortGroup_Variable_GroupAutoActivate' " .. tostring(SortGroup_Variable_GroupAutoActivate));
				print("'SortGroup_Variable_RegardlessRaidProfile' " .. tostring(SortGroup_Variable_RegardlessRaidProfile));
				print("'SortGroup_Variable_Page3_chatMessagesOn' " .. tostring(SortGroup_Variable_Page3_chatMessagesOn));
				print("'SortGroup_Variable_Page2_AdditionalSwitchActive' " .. tostring(SortGroup_Variable_Page2_AdditionalSwitchActive));
				print("'RaidProfileOnLoad' " .. tostring(RaidProfileOnLoad));
				print("'SortGroup_Variable_Page3_ChangesInCombat' " .. tostring(SortGroup_Variable_Page3_ChangesInCombat));
				print("'SortGroup_Variable_Page3_RaidProfilesUpdateInCombat' " .. tostring(SortGroup_Variable_Page3_RaidProfilesUpdateInCombat));
			end
		end
		if ( ( SortGroup_Variable_debugLevelCache == 2 or SortGroup_Variable_debugLevelCache == 6 ) and methodLevel >= 2 ) then
			if ( SortGroup_Variable_debugMethodNameCache ~= methodName ) then
				if ( SortGroup_Variable_debugMethodNamePrint == true ) then
					print(ColorPrint("SortGroup: Debuging - Method Names", "option"));
					SortGroup_Variable_debugMethodNamePrint = false;
				end
				print("'" ..  methodName .. "()'");
				SortGroup_Variable_debugMethodNameCache = methodName;
			end
		end
		if ( SortGroup_Variable_debugLevelCache >= 4 and methodLevel == 3 ) then
			SortGroup_Variable_debugMethodNamePrint = true;
			if ( SortGroup_Variable_debugMethodContentCache ~= methodName ) then
				print(ColorPrint("SortGroup: Debuging - Method content", "option"));	
			end
			SortGroup_Variable_debugMethodContentCache = methodName;
			print( "'" .. methodName .. "()' " .. tostring(methodContent));
		end		
	end
end
-- Debug, goes through everything

local function StartAddon()
	Debug("StartAddon", "", 2);
	createFrame();
	createText();
	createCheckbox();
	createButton();
	createDropDownMenu();
	createSliders();
	frameEvent();	
	checkBoxEvent();
	buttonEvent();
	SliderEvent();
end
StartAddon();